//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef APPLICATION_COMMAND_LINE_H
#define APPLICATION_COMMAND_LINE_H

#include <string>

namespace Ge
{

class Command;

// This class represents a command line that can be entered in the console or
// read from a .set file
class CommandLine
{
public:
    CommandLine(const char* line);
    ~CommandLine();

    bool isComment() const;
    bool isValid() const;
    void execute(std::string* consoleOutput = 0) const;

private:
    Command* mCommand;
    bool mComment;
};

} // namespace Ge

#endif // APPLICATION_COMMAND_LINE_H