//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef APPLICATION_FRAMEWORK_H
#define APPLICATION_FRAMEWORK_H

#include <System/Base.h>
#include <string>

namespace Ge
{

class Renderer;
class Context;

//This class represents a simple application framework. Create a subclass
//for your own use.
class Framework
{
public:
    virtual ~Framework();

    virtual void init();
    
    virtual void update();
    
    virtual void render();

    virtual void exit();

    // No ownership of the Context is currently taken. I.e. the user must
    // assure that the memory of the Context gets cleaned up.
    void setActiveContext(Context&);

    Context* getActiveContext();

    const Context* getActiveContext() const;

    Handle getWindow();

protected:
    Framework(const char* settingsFileName);
    
    virtual Handle createWindow() = 0;

private:
    Handle mWindow;
    std::string mSettingsName;
    Context* mActiveContext;
};

} // namespace Ge

#endif // APPLICATION_FRAMEWORK_H