#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 03-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include "Metronome.h"

namespace Ge
{

//------------------------------------------------------------------------------
Metronome& Metronome::instance()
//------------------------------------------------------------------------------
{
    static Metronome m;
    return m;
}


//------------------------------------------------------------------------------
Metronome::Metronome() :
//------------------------------------------------------------------------------
mTimeAtUpdate(0),
mDelta(0),
mUpdateCount(0)
{
}


//------------------------------------------------------------------------------
Timer::Unit Metronome::getAbsolute()
//------------------------------------------------------------------------------
{
    return mTimeAtUpdate;
}

//------------------------------------------------------------------------------
Timer::Unit Metronome::getDelta()
//------------------------------------------------------------------------------
{
    return mDelta;
}

//------------------------------------------------------------------------------
void Metronome::update()
//------------------------------------------------------------------------------
{
    Timer::Unit lastUpdate(mTimeAtUpdate);
    mTimeAtUpdate = mTime.get(Timer::MILLISECONDS);
    mDelta = mTimeAtUpdate - lastUpdate;
    mUpdateCount++;
}

//------------------------------------------------------------------------------
UInt Metronome::getUpdateCount() const
//------------------------------------------------------------------------------
{
    return mUpdateCount;
}

}
