#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 03-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include "ScaledMetronome.h"
#include "Metronome.h"

namespace Ge
{

//------------------------------------------------------------------------------
ScaledMetronome& ScaledMetronome::instance()
//------------------------------------------------------------------------------
{
    static ScaledMetronome sm;
    return sm;
}


//------------------------------------------------------------------------------
ScaledMetronome::ScaledMetronome() :
//------------------------------------------------------------------------------
mTimeAtUpdate(theMetronome().getAbsolute()),
mDelta(0),
mRatio(1)
{
}


//------------------------------------------------------------------------------
Timer::Unit ScaledMetronome::getAbsolute()
//------------------------------------------------------------------------------
{
    return mTimeAtUpdate;
}

//------------------------------------------------------------------------------
Timer::Unit ScaledMetronome::getDelta()
//------------------------------------------------------------------------------
{
    return mDelta;
}

//------------------------------------------------------------------------------
void ScaledMetronome::update()
//------------------------------------------------------------------------------
{
    mDelta = mRatio*theMetronome().getDelta();
    mTimeAtUpdate += mDelta;
}

//------------------------------------------------------------------------------
void ScaledMetronome::setRatio(Float r)
//------------------------------------------------------------------------------
{
    mRatio = r;
}

//------------------------------------------------------------------------------
Float ScaledMetronome::getRatio()
//------------------------------------------------------------------------------
{
    return mRatio;
}

}
