//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef APPLICATION_STRING_ID_H
#define APPLICATION_STRING_ID_H

#include <string>

namespace Ge
{

// This class provides a typesafe way of accessing strings in
// a StringMap (this way StringIds cannot be confused with
// strings). Load different .str files using
// StringMap::load() and then access the strings through
// StringIds.
class StringId
{
public:
    explicit
    StringId(const char* id);

    const std::string& getString() const;

    const std::string& getId() const;
    void setId(const char* id);

private:
    std::string mId;
};


} // namespace Ge

#endif // APPLICATION_STRING_ID_H

