//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef APPLICATION_STRING_MAP_H
#define APPLICATION_STRING_MAP_H

#include <System/Base.h>
#include <System/StringTools.h>
#include <map>
#include <fstream>

namespace Ge
{

#define theStringMap StringMap::instance()

// StringMap files may contain the following types of lines:
// "IDENTIFIER Text~" (texts can span multiple lines, but must be limited
//                     with a '~' character)
// "Blank lines"
// "// Comments"

// The strings in the map cannot be accessed directly. Use StringIds
// for that purpose.
class StringMap
{
public:
    static
    StringMap& instance();

    bool load(const char* fileName);
    UInt getSize() const;

private:
    StringMap();
    friend class StringId;
    const std::string& get(const StringId& identifier) const;
    bool parse(std::istream&);

    typedef std::map<std::string, std::string, StringTools::Pred> Map;
    mutable Map mMap;
};

} // namespace Ge

#endif // APPLICATION_STRING_MAP_H