//------------------------------------------------------------------------------
// (c) 04-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include <Sound/SoundDevice.h>
#include <Sound/Mp3Player.h>
#include <fstream>
#include <windows.h>

namespace Ge
{

//------------------------------------------------------------------------------
SoundDevice::SoundDevice()
//------------------------------------------------------------------------------
{
    mMp3Player = new Mp3Player(GetModuleHandle(0));
}


//------------------------------------------------------------------------------
SoundDevice::~SoundDevice()
//------------------------------------------------------------------------------
{
    delete mMp3Player;
}


//------------------------------------------------------------------------------
SoundDevice& SoundDevice::instance()
//------------------------------------------------------------------------------
{
    static SoundDevice theDevice;
    return theDevice;
}

//------------------------------------------------------------------------------
SoundDevice::Error SoundDevice::playMusicTrack(const char* file)
//------------------------------------------------------------------------------
{
    Error ret(OK);
    if (strlen(file) > 0)
    {
        std::ifstream test(file, std::ios::in);
        if (test.good())
        {
            mMp3Player->InputOpen(file);
            mMp3Player->Play();
        }
    }
    else
        ret = TRACK_NOT_FOUND;

    return OK;
}

} // namespace Ge