//------------------------------------------------------------------------------
// (c) 06-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef DIRECTX_RENDERER_DIRECTX_TEXTURE_H
#define DIRECTX_RENDERER_DIRECTX_TEXTURE_H

#include <Engine/Texture.h>

struct IDirect3DTexture8;

namespace Ge
{

class Image;
class DirectXRenderer;

// Textures that are internally represented by a DirectX only
// understandable format.
class DirectXTexture : public Texture
{
public:
    ~DirectXTexture();
 
    IDirect3DTexture8* getDirect3dTexture() const;

    virtual
    Image* convertToImage() const;

private:
    friend class DirectXTexturePool;
    friend class XImporter;

    DirectXTexture(IDirect3DTexture8&, const char* name,
                   const DirectXRenderer&, Filtering = FILTER_DEFAULT);

    DirectXTexture(const char* file, const DirectXRenderer&,
                   Filtering = FILTER_DEFAULT);

    DirectXTexture(const Image&, const char* name,
                   const DirectXRenderer&, Filtering = FILTER_DEFAULT);

    // This constructs a Direct3d compatible texture from <image>
    void createFromImage(Image& image);


    IDirect3DTexture8* mTexture;
    const DirectXRenderer& mRenderer;
};

} // namespace Ge

#endif // DIRECTX_RENDERER_DIRECTX_TEXTURE_H