#ifndef DIRECTX_RENDERER_DIRECTX_TEXTUREPOOL_H
#define DIRECTX_RENDERER_DIRECTX_TEXTUREPOOL_H

#include <DirectXRenderer/DirectXRenderer.h>
#include <Engine/TexturePool.h>

namespace Ge
{

// When using the DirectXRenderer use this TexturePool
class DirectXTexturePool : public TexturePool
{
public:
    DirectXTexturePool(const DirectXRenderer&,
                       Texture::Filtering = Texture::FILTER_DEFAULT);

    virtual
    Texture* get(const char* file);

    virtual
    Texture* get(zip::izipfile&, const char* file);

    virtual
    Texture* get(const Image&, const char* name);
   
private:
    const DirectXRenderer& mRenderer;
};

} // namespace Ge

#endif // DIRECTX_RENDERER_DIRECTX_TEXTUREPOOL_H