//------------------------------------------------------------------------------
// (c) 06-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef ENGINE_ANIMATION_KEY_H
#define ENGINE_ANIMATION_KEY_H

#include <System/Timer.h>

namespace Ge
{

// Base class representing a key for any key based TimeController. Stores
// the key's time. Derive from it and store your key data in the derived class.
class AnimationKey
{
public:    
    AnimationKey();

    void setTime(const Timer::Unit&);
    const Timer::Unit& getTime() const;

private:
    Timer::Unit mTime;
};

} // namespace Ge

#endif // ENGINE_ANIMATION_KEY_H