//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include <Engine/AlphaState.h>
#include <Engine/Renderer.h>

namespace Ge
{

//------------------------------------------------------------------------------
AlphaState::AlphaState(Mode mode) :
//------------------------------------------------------------------------------
RenderState(ALPHA),
mMode(mode)
{
}

//------------------------------------------------------------------------------
void AlphaState::set(const Renderer& renderer) const
//------------------------------------------------------------------------------
{
    renderer.set(*this);
}

//------------------------------------------------------------------------------
void AlphaState::set(Mode mode)
//------------------------------------------------------------------------------
{
    mMode = mode;
}

//------------------------------------------------------------------------------
AlphaState::Mode AlphaState::getMode() const
//------------------------------------------------------------------------------
{
    return mMode;
}


//------------------------------------------------------------------------------
bool AlphaState::equals(const RenderState& state) const
//------------------------------------------------------------------------------
{
    bool ret(false);
    if (getType() == state.getType())
    {
        if (static_cast<const AlphaState&>(state).getMode() == getMode())
            ret = true;
    }

    return ret;
}

} // namespace Ge