//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef ENGINE_ALPHA_STATE_H
#define ENGINE_ALPHA_STATE_H

#include <Engine/RenderState.h>

namespace Ge
{

class AlphaState : public RenderState
{
public:
    enum Mode
    {
        OFF,
        SOURCE_ALPHA,
        SOURCE_COLOR,
        DEFAULT = OFF
    };

    AlphaState(Mode mode = DEFAULT);

    virtual
    void set(const Renderer&) const;

    void set(Mode);
    Mode getMode() const;

    virtual
    bool equals(const RenderState&) const;

private:
    Mode mMode;
};

} // namespace Ge

#endif // ENGINE_ALPHA_STATE_H
