#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include <Engine/Billboard.h>
#include <Engine/Renderer.h>
#include <Engine/Camera.h>

namespace Ge
{

//------------------------------------------------------------------------------
void Billboard::accumulate(Sorter& sorter, const Camera& camera,
                           bool continueCulling)
//------------------------------------------------------------------------------
{
    Intersect::Type intersect(cull(camera, continueCulling));
    if (intersect != Intersect::DISJOINT)
    {
        setCamera(camera);
        if (intersect == Intersect::CONTAINS)
            accumulateChildren(sorter, camera, false);
        else if (intersect == Intersect::INTERSECTS)
            accumulateChildren(sorter, camera, true);
    }
}

//------------------------------------------------------------------------------
void Billboard::setCamera(const Camera& camera)
//------------------------------------------------------------------------------
{
    Matrix3x3 billboard;
    camera.getLocator().getGlobal().getSubMatrix(billboard);
    localTransform().setRotation(billboard);
    //updateGeometry(); ### -> Not needed, since my bounding volumes are
    // spheres. If  they were OBBs -> this must be done to have correct
    // bounding volumes
    updateTransform();
}

//------------------------------------------------------------------------------
AudioVisual* Billboard::clone() const
//------------------------------------------------------------------------------
{
    Billboard* ret = GE_NEW Billboard;
    ret->copyDataFrom(*this);
    return ret;
}

} // namespace Ge
