//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef ENGINE_DEFAULT_SORTER_H
#define ENGINE_DEFAULT_SORTER_H

#include <Engine/Sorter.h>
#include <vector>

namespace Ge
{

class DefaultSorter : public Sorter
{
public:
    virtual
    void accumulate(AudioVisual&);

    virtual
    void render(Renderer&);

private:
    struct AlphaObject
    {
        AlphaObject(Float d, AudioVisual* av) : mObject(av), mDistance(d) {}
        // Needed for sorting
        bool operator <(const AlphaObject& rhs) { return mDistance < rhs.mDistance; }

        AudioVisual* mObject;
        Float mDistance;
    };

    typedef std::vector<AudioVisual*> Vector;
    typedef std::vector<AlphaObject> AlphaVector;
    Vector mOpaque;
    AlphaVector mAlpha;
};

} // namespace Ge

#endif // ENGINE_SORTER_H