//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include <Engine/FillState.h>
#include <Engine/Renderer.h>

namespace Ge
{

//------------------------------------------------------------------------------
FillState::FillState(Mode mode) :
//------------------------------------------------------------------------------
RenderState(FILL_MODE),
mMode(mode)
{
}

//------------------------------------------------------------------------------
void FillState::set(const Renderer& renderer) const
//------------------------------------------------------------------------------
{
    renderer.set(*this);
}

//------------------------------------------------------------------------------
void FillState::set(Mode mode)
//------------------------------------------------------------------------------
{
    mMode = mode;
}

//------------------------------------------------------------------------------
FillState::Mode FillState::getMode() const
//------------------------------------------------------------------------------
{
    return mMode;
}

//------------------------------------------------------------------------------
bool FillState::equals(const RenderState& state) const
//------------------------------------------------------------------------------
{
    bool ret(false);
    if (getType() == state.getType())
    {
        if (static_cast<const FillState&>(state).getMode() == getMode())
            ret = true;
    }

    return ret;
}

} // namespace Ge