//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef ENGINE_FILL_STATE_H
#define ENGINE_FILL_STATE_H

#include <Engine/RenderState.h>

namespace Ge
{

class FillState : public RenderState
{
public:
    enum Mode
    {
        SOLID,
        WIREFRAME,
        POINT,
        DEFAULT = SOLID
    };

    FillState(Mode mode = DEFAULT);

    virtual
    void set(const Renderer&) const;
    
    void set(Mode mode);
    Mode getMode() const;

    virtual
    bool equals(const RenderState&) const;

private:
    Mode mMode;
};

} // namespace Ge

#endif // ENGINE_FILL_STATE_H
