#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 04-2001 Gottfried Chen
//------------------------------------------------------------------------------

#pragma warning(disable: 4786)

#include <Engine/Geometry.h>
#include <Engine/GeometryData.h>
#include <Engine/Renderer.h>

namespace Ge
{

//------------------------------------------------------------------------------
Geometry::Geometry(const GeometryData& data) :
//------------------------------------------------------------------------------
mData(&data)
{
}

//------------------------------------------------------------------------------
void Geometry::render(Renderer& renderer)
//------------------------------------------------------------------------------
{
    // Sets the correct world matrix
    renderer.render(*this);
    // Render the data
    mData->render(renderer);
}

//------------------------------------------------------------------------------
void Geometry::updateBoundDown()
//------------------------------------------------------------------------------
{
    // Transform the model space bounding volume to world space
//    Matrix4 world;
//    worldTransform().getMatrix4(world);

    setBound(Sphere(worldTransform().getMatrix3x3()*mData->getBound().getCenter() +
                    worldTransform().getTranslation(),
                    worldTransform().getScale()*mData->getBound().getRadius()));
}

//------------------------------------------------------------------------------
AudioVisual* Geometry::clone() const
//------------------------------------------------------------------------------
{
    Geometry* ret = GE_NEW Geometry(*mData);
    ret->copyDataFrom(*this);
    return ret;
}

} // namespace Ge
