//------------------------------------------------------------------------------
// (c) 04-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef ENGINE_GEOMETRY_H
#define ENGINE_GEOMETRY_H

#include <Engine/AudioVisual.h>
#include <System/Pointer.h>

namespace Ge
{

class Renderer;
class GeometryData;

// Geometry controls the transforms of a model to be rendered.
// The actual data is referenced via a pointer to GeometryData,
// so models can be shared.
class Geometry : public AudioVisual
{
public:
    Geometry(const GeometryData& data);

    virtual
    void render(Renderer& renderer);

    virtual
    AudioVisual* clone() const;

protected:
    virtual
    void updateBoundDown();

private:
    Pointer<const GeometryData> mData;
};

} // namespace Ge

#endif // ENGINE_GEOMETRY_H