//------------------------------------------------------------------------------
// (c) 04-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef ENGINE_GEOMETRY_DATA_H
#define ENGINE_GEOMETRY_DATA_H

#include <System/Object.h>
#include <Math/Sphere.h>

namespace Ge
{

class Renderer;

// Base class for shared geometry data.
class GeometryData : public Object
{
public:
    virtual
    void render(Renderer& renderer) const = 0;

    // This is a model space bound
    virtual
    Sphere getBound() const = 0;
};

}

#endif // ENGINE_GEOMETRY_DATA_H