//------------------------------------------------------------------------------
// (c) 06-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include <Engine/MaterialState.h>
#include <Engine/Renderer.h>

namespace Ge
{

//------------------------------------------------------------------------------
MaterialState::MaterialState(Material& material) :
//------------------------------------------------------------------------------
RenderState(MATERIAL),
mMaterial(&material)
{
}

//------------------------------------------------------------------------------
void MaterialState::set(const Renderer& renderer) const
//------------------------------------------------------------------------------
{
    renderer.set(*this);
}

//------------------------------------------------------------------------------
bool MaterialState::equals(const RenderState& state) const
//------------------------------------------------------------------------------
{
    bool ret(false);
    if (getType() == state.getType())
    {
        const MaterialState& material = static_cast<const MaterialState&>(state);
        ret = (material.mMaterial == mMaterial);
    }

    return ret;
}

//------------------------------------------------------------------------------
const Material& MaterialState::material() const
//------------------------------------------------------------------------------
{
    GE_ASSERT(mMaterial != 0);
    return *mMaterial;
}

//------------------------------------------------------------------------------
Material& MaterialState::material()
//------------------------------------------------------------------------------
{
    GE_ASSERT(mMaterial != 0);
    return *mMaterial;
}

} // namespace Ge
