//------------------------------------------------------------------------------
// (c) 06-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef ENGINE_MATERIAL_STATE_H
#define ENGINE_MATERIAL_STATE_H

#include <System/Pointer.h>

#include <Engine/Material.h>
#include <Engine/RenderState.h>

namespace Ge
{

class MaterialState : public RenderState
{
public:
    // Default material is ambient, diffuse white, rest is black
    // <material> must be on the heap
    MaterialState(Material& material);

    const Material& material() const;
    Material& material();

    virtual
    void set(const Renderer&) const;

    // Two MaterialStates are the same, if the <mMaterial> pointers are
    // the same (not comparison by value is done)
    virtual
    bool equals(const RenderState&) const;

private:
    Pointer<Material> mMaterial;
};

} // namespace Ge

#endif // ENGINE_MATERIAL_STATE_H