//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef ENGINE_RENDER_STATE_H
#define ENGINE_RENDER_STATE_H

#include <System/Object.h>

namespace Ge
{

class Renderer;

// Base class for all render states.
class RenderState : public Object
{
public:
    enum Type
    {
        ALPHA,
        FILL_MODE,
        SHADE_MODE,
        LIGHTING,
        SPECULAR,
        TEXTURE_SET,
        MATERIAL,
        TYPE_COUNT
    };

    Type getType() const;

    virtual
    void set(const Renderer&) const = 0;

    virtual
    bool equals(const RenderState&) const = 0;

protected:
    RenderState(Type);

private:
    Type mType;
};

} // namespace Ge

#endif // ENGINE_RENDER_STATE_H
