//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include <Engine/SpecularState.h>
#include <Engine/Renderer.h>

namespace Ge
{

//------------------------------------------------------------------------------
SpecularState::SpecularState(Mode mode) :
//------------------------------------------------------------------------------
RenderState(SPECULAR),
mMode(mode)
{
}

//------------------------------------------------------------------------------
void SpecularState::set(const Renderer& renderer) const
//------------------------------------------------------------------------------
{
    renderer.set(*this);
}

//------------------------------------------------------------------------------
void SpecularState::set(Mode mode)
//------------------------------------------------------------------------------
{
    mMode = mode;
}

//------------------------------------------------------------------------------
SpecularState::Mode SpecularState::getMode() const
//------------------------------------------------------------------------------
{
    return mMode;
}


//------------------------------------------------------------------------------
bool SpecularState::equals(const RenderState& state) const
//------------------------------------------------------------------------------
{
    bool ret(false);
    if (getType() == state.getType())
    {
        if (static_cast<const SpecularState&>(state).getMode() == getMode())
            ret = true;
    }

    return ret;
}

} // namespace Ge