//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef ENGINE_SPECULAR_STATE_H
#define ENGINE_SPECULAR_STATE_H

#include <Engine/RenderState.h>

namespace Ge
{

// Controls rendering of specular highlights for a subtree
class SpecularState : public RenderState
{
public:
    enum Mode
    {
        ON,
        OFF,
        DEFAULT = OFF
    };

    SpecularState(Mode mode = DEFAULT);

    virtual
    void set(const Renderer&) const;

    void set(Mode);
    Mode getMode() const;

    virtual
    bool equals(const RenderState&) const;

private:
    Mode mMode;
};

} // namespace Ge

#endif // ENGINE_SPECULAR_STATE_H
