//------------------------------------------------------------------------------
// (c) 06-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef ENGINE_TEXTURE_STATE_H
#define ENGINE_TEXTURE_STATE_H

#include <Engine/RenderState.h>
#include <Engine/Texture.h>

#include <System/Pointer.h>

#include <vector>

namespace Ge
{

// A TextureState represents a set of textures to be used for the subtree
// it is attached to. (No multiple texturing is supported yet, since I don't
// need it now)
class TextureState : public RenderState
{
public:
    TextureState(const Texture&);

    virtual
    void set(const Renderer&) const;

    // Two TextureStates are the same, if the underlying textures have the same
    // name
    virtual
    bool equals(const RenderState&) const;

    void begin() const;
    const Texture* next() const;
    
    bool isNull() const;
    // ### ToDo: Add blend modi of the different textures, when multitexturing

private:
    friend class Renderer;
    TextureState();

    //std::vector<Pointer<Texture> > mTextures;
    Pointer<const Texture> mTexture;
    mutable bool mCursor;
    bool mIsNull;
};

} // namespace Ge

#endif // ENGINE_TEXTURE_STATE_H