#ifndef ENGINE_BUMP_MATERIAL_H
#define ENGINE_BUMP_MATERIAL_H
#pragma once

//------------------------------------------------------------------------------
// (c) Sep-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "Material.h"

namespace Ge
{

class Link;

class BumpMaterial : public Material
{
public:
    BumpMaterial();

    virtual
    void apply(UInt pass, const Matrix4x4& view) const;

    virtual
    Material* clone() const;

//    virtual
//    UInt getType() const;

    void activateSpecular(bool);

private:
    void diffusePass() const;    
    void updateTangentLight() const;
    void specularPass() const;
    void updateHalfAngleLight(const Matrix4x4& view) const;
};

} // namespace Ge

#endif // !ENGINE_BUMP_MATERIAL_H