#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 07-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include <Engine/CoordinateAxes.h>
#include <Engine/Lines.h>
#include <Engine/Color.h>

namespace Ge
{

//------------------------------------------------------------------------------
Lines* CoordinateAxes::create(const Float& axisLength)
//------------------------------------------------------------------------------
{
    GE_ASSERT(axisLength > EPSILON);

    Vector3* vertices = GE_NEW Vector3[6];
    Color* colors = GE_NEW Color[6];
    UInt16* indices = GE_NEW UInt16[6];

    for (UInt i = 0; i<6; i += 2)
    {
        vertices[i] = Vector3(0,0,0);
    }

    vertices[1] = Vector3(axisLength,0,0);
    vertices[3] = Vector3(0,axisLength,0);
    vertices[5] = Vector3(0,0,axisLength);
    
    // X is red
    colors[0].setFloat(1,0,0,1);
    colors[1].setFloat(1,0,0,1);
    // Y is green
    colors[2].setFloat(0,1,0,1);
    colors[3].setFloat(0,1,0,1);
    // Z is blue
    colors[4].setFloat(0,0,1,1);
    colors[5].setFloat(0,0,1,1);

    for (UInt j = 0; j<6; ++j)
    {
        indices[j] = j;
    }

    return  GE_NEW Lines(6, vertices, colors,
                         6, indices);
}

} // namespace Ge
