#ifndef ENGINE_EDGE_H
#define ENGINE_EDGE_H
#pragma once

//------------------------------------------------------------------------------
// (c) Aug-2002 Gottfried Chen
//------------------------------------------------------------------------------

namespace Ge
{

class Edge
{
public:

    Vector3& operator [](UInt index)
    {
        return mData[index];
    }

    const Vector3& operator [](UInt index) const
    {
        return mData[index];
    }

    // Two edges in different triangles coincide if they contain the
    // same vertices but in different winding order.
    bool operator ==(const Edge& rhs) const
    {
        return  //(mData[0] == rhs.mData[0] && mData[1] == rhs.mData[1]) ||
               (mData[0] == rhs.mData[1] && mData[1] == rhs.mData[0]);
    }

    bool operator !=(const Edge& rhs) const
    {
        return !(*this == rhs);
    }

private:
    // Storing the indices is not enough because vertices with same
    // positions but different colors would have different indices.
    Vector3 mData[2];
};

} // namespace Ge

#endif // !ENGINE_EDGE_H