//------------------------------------------------------------------------------
// (c) 06-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef ENGINE_KEYFRAME_CONTROLLER_H
#define ENGINE_KEYFRAME_CONTROLLER_H

#include <Engine/Vector3Controller.h>

namespace Ge
{

// KeyframeControllers are TimeControllers used for keyframe animation.
// Examples are Position/Rotation/ScaleControllers. A KeyframeController
// modifies an attached Locator.
class KeyframeController : public Vector3Controller
{
public:    
    KeyframeController();

    virtual
    void attachTo(Locator&);

protected:
    Locator* getLocator() const;

private:
    Locator* mLocator;
};

} // namespace Ge

#endif // ENGINE_KEYFRAME_CONTROLLER_H