#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 04-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include "Light.h"

namespace Ge
{

//------------------------------------------------------------------------------
Light::Light() :
//------------------------------------------------------------------------------
mColor(Color::WHITE),
mPosition(0,0,0,1),
mRange(1)
{
}

//------------------------------------------------------------------------------
void Light::setColor(const Color& c)
//------------------------------------------------------------------------------
{
    mColor = c;
}

//------------------------------------------------------------------------------
const Color& Light::getColor() const
//------------------------------------------------------------------------------
{
    return mColor;
}

//------------------------------------------------------------------------------
Float Light::getRange() const
//------------------------------------------------------------------------------
{
    return mRange;
}

//------------------------------------------------------------------------------
void Light::setRange(const Float& r)
//------------------------------------------------------------------------------
{
    mRange = r;
}

//------------------------------------------------------------------------------
const Vector4& Light::getPosition() const
//------------------------------------------------------------------------------
{
    return mPosition;
}

//------------------------------------------------------------------------------
void Light::setPosition(const Vector4& p)
//------------------------------------------------------------------------------
{
    mPosition = p;
}

} // namespace Ge