#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 12-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include "LwoImporter.h"
#include <System/ByteOrder.h>
#include <iostream>
#include <fstream>

//------------------------------------------------------------------------------
// Helpers
//------------------------------------------------------------------------------

namespace
{

using namespace Ge;

class Tag
{
public:
    Tag(int label, unsigned int size);

    int getLabel() const { return mLabel; }
    unsigned int getSize() const { return mSize; }

private:
    int mLabel;
    unsigned int mSize;
};

//------------------------------------------------------------------------------
Tag::Tag(int label, unsigned int size)
//------------------------------------------------------------------------------
{
    theByteOrder.from(label, ByteOrder::MSB);
    theByteOrder.from(size, ByteOrder::MSB);

    mLabel = label;
    mSize = size;
}

// If the next chunk is <name>, then return the cunk's size
//------------------------------------------------------------------------------
Tag getTag(std::istream& stream)
//------------------------------------------------------------------------------
{
    int tag;
    stream.read(reinterpret_cast<char*>(&tag), 4);

    unsigned int size;
    stream.read(reinterpret_cast<char*>(&size), 4);

    return Tag(tag, size);
}

// Returns size left to read (i.e. of the form chunk
//------------------------------------------------------------------------------
bool isFileOk(std::istream& stream)
//------------------------------------------------------------------------------
{
    Tag tag = getTag(stream);
    bool ret = false;
    if (tag.getLabel() == 'FORM')
    {
        int formType;
        stream.read(reinterpret_cast<char*>(&formType), 4);
        theByteOrder.from(formType, ByteOrder::MSB);
        ret = formType == 'LWO2';
    }

    return ret;
}

//------------------------------------------------------------------------------
void readVertices(std::istream& stream, Vector3*& vertices)
//------------------------------------------------------------------------------
{
//    if (vertices == 0)
//    {
//        unsigned int size = 0;
//        stream.read(reinterpret_cast<char*>(&size), 4);
//        theByteOrder.from(size,
//    }
//    else
//        GE_ASSERT_MSG(false, 
}

} // namespace








//------------------------------------------------------------------------------
// Importer
//------------------------------------------------------------------------------

namespace Ge
{

//------------------------------------------------------------------------------
void LwoImporter::test()
//------------------------------------------------------------------------------
{
    using namespace std;
    ifstream file("E:\\Stuff\\Docs\\Computer\\LightwaveSDK\\docs\\filefmts\\lwo2ex\\cube.lwo",
                  std::ios_base::binary);

    if (isFileOk(file))
        std::cout<<"Valid .lwo file\n";
    else
        std::cout<<"Test failed\n";
}

//------------------------------------------------------------------------------
LwoImporter::LwoImporter(const char* fileName, TexturePool&)
//------------------------------------------------------------------------------
{
}

} // namespace Ge