//------------------------------------------------------------------------------
// (c) 06-2001 Gottfried Chen
//------------------------------------------------------------------------------
#ifndef ENGINE_LWO_IMPORTER_H
#define ENGINE_LWO_IMPORTER_H

#include <vector>
#include <Math/Vector.h>

namespace Ge
{

class AudioVisual;
class TexturePool;

// This class doesn't import .lwo files (yet)!
class LwoImporter
{
public:
    static
    void test();

    // Transforms to a model. If <importMaterialAndTexture> is true, then material
    // information will also be imported, when there is a texture.
    // Otherwise only the texture will be imported.
    AudioVisual* import(bool importMaterialAndTexture = false) const;

private:
    friend class ModelPool;
    
    LwoImporter(const char* fileName, TexturePool&);

    Vector3* mVertices;
    unsigned int mVertexCount;

    UInt16* mIndices;
    unsigned int mIndexCount;
};

} // namespace Ge

#endif // ENGINE_LWO_IMPORTER_H