#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) Aug-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "MorphAnimation.h"
#include "Mesh.h"

namespace Ge
{

//------------------------------------------------------------------------------
MorphAnimation::MorphAnimation() :
//------------------------------------------------------------------------------
mMesh(0),
mStart(0),
mEnd(0),
mCurrent(0),
mRepeat(TimeController::LOOP)
{
}

//------------------------------------------------------------------------------
void MorphAnimation::set(TimeController::Repeat repeat)
//------------------------------------------------------------------------------
{
    mRepeat = repeat;
}
    
//------------------------------------------------------------------------------
TimeController::Repeat MorphAnimation::getRepeatType() const
//------------------------------------------------------------------------------
{
    return mRepeat;
}

//------------------------------------------------------------------------------
void MorphAnimation::setInterval(UInt startFrame, UInt endFrame)
//------------------------------------------------------------------------------
{
    GE_ASSERT(startFrame <= endFrame);
    if (startFrame <= endFrame)
    {
        mStart = startFrame;
        mEnd = endFrame;
    }
    else
    {
        mStart = 0;
        mEnd = 0;
    }

    mCurrent = mStart;
}

//------------------------------------------------------------------------------
void MorphAnimation::getInterval(UInt& startFrame, UInt& endFrame) const
//------------------------------------------------------------------------------
{
    startFrame = startFrame;
    endFrame = endFrame;
}


//------------------------------------------------------------------------------
void MorphAnimation::update()
//------------------------------------------------------------------------------
{
    GE_ASSERT(mMesh != 0);
    if (mMesh != 0)
    {
        GE_ASSERT_MSG(false, "Implement.");
    }
}

//------------------------------------------------------------------------------
void MorphAnimation::attachTo(Mesh& m)
//------------------------------------------------------------------------------
{
    mMesh = &m;
}

} // namespace Ge
