#ifndef ENGINE_MORPH_ANIMATION_H
#define ENGINE_MORPH_ANIMATION_H
#pragma once

//------------------------------------------------------------------------------
// (c) Aug-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "TimeController.h"

namespace Ge
{

class Mesh;

class MorphAnimation
{
public:
    MorphAnimation();

    void set(TimeController::Repeat);
    
    TimeController::Repeat getRepeatType() const;

    void setInterval(UInt startFrame, UInt endFrame);

    void getInterval(UInt& startFrame, UInt& endFrame) const;

    // Set the animation speed in frames per second.
    void setFps(UInt);

    UInt getFps() const;

    void update();

    void attachTo(Mesh&);

private:
    Mesh* mMesh;
    UInt mStart;
    UInt mEnd;
    UInt mFps;
    UInt mCurrent;
    TimeController::Repeat mRepeat;
};

} // namespace Ge

#endif // !ENGINE_MORPH_ANIMATION_H