#ifndef ENGINE_PARTICLE_H
#define ENGINE_PARTICLE_H
#pragma once

//------------------------------------------------------------------------------
// (c) Aug-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "Color.h"

#include <Math/Vector.h>

#include <utility>


namespace Ge
{

class Emitter;

class Particle
{
public:
    // No initialisation except that isAlive() returns false.
    Particle();

    void init(const Vector3& position, const Vector3& speed, const Emitter*);
    
    // Returns false if the Particle died.
    bool update();

    bool isAlive() const;

    const Vector3& getPosition() const;

    const Color& getColor() const;

    Float getSize() const;

    Float getAngle() const;

private:

    const Emitter* mEmitter;
    Vector3 mPosition; // In world space
    Vector3 mSpeed;
    Float mAge;
    Float mSize;
    Float mAngle;
    Float mStartAngle;
    Color mColor;
};

} // namespace Ge

#endif // !ENGINE_PARTICLE_H