#ifndef ENGINE_PICK_H
#define ENGINE_PICK_H
#pragma once

//------------------------------------------------------------------------------
// (c) Jun-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include <System/Types.h>

#include <Math/Ray.h>

namespace Ge
{

class Camera;

class Pick
{
public:
    // Doesn't do anything
    Pick();

    Pick(const Camera&, Handle window);

    // Returns a ray in world space from the camera pointing to the current
    // mouse position.
    const Ray& getMouseRay() const;

    // Recalculate the mouse ray. The mouse and camera have to be updated
    // by the user.
    void update();

    void setCamera(const Camera&);

    void setWindow(Handle window);

private:
    const Camera* mCamera;
    Handle mWindow;
    Ray mRay;
};

} // namespace Ge

#endif // !ENGINE_PICK_H