#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include <Engine/Quad.h>
#include <Engine/Mesh.h>
#include <Engine/Material.h>

namespace Ge
{

//------------------------------------------------------------------------------
Mesh* Quad::create(Float width, Float height)
//------------------------------------------------------------------------------
{
    Vector3* vertices = GE_NEW Vector3[4];
    Vector3* normals = GE_NEW Vector3[4];
    Vector2* textureUvs = GE_NEW Vector2[4];
    UInt16* indices = GE_NEW UInt16[6];
  
    width /= 2.0f;
    height /= 2.0f;

    vertices[0] = Vector3(-width, -height, 0);
    vertices[1] = Vector3(-width, height, 0);
    vertices[2] = Vector3(width, -height, 0);
    vertices[3] = Vector3(width, height, 0);

    normals[0] = normals[1] = normals[2] = normals[3] = Vector3(0,0,-1);

    textureUvs[0] = Vector2(0,1);
    textureUvs[1] = Vector2(0,0);
    textureUvs[2] = Vector2(1,1);
    textureUvs[3] = Vector2(1,0);

    indices[0] = 0;
    indices[1] = 1;
    indices[2] = 2;
    indices[3] = 1;
    indices[4] = 3;
    indices[5] = 2;
    
    Mesh* mesh = GE_NEW Mesh(1,
                             4, vertices, normals, textureUvs, 0,
                             6, indices);
    mesh->calculateBound();
    return mesh;
}

} // namespace Ge
