//------------------------------------------------------------------------------
// (c) 04-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef ENGINE_RENDER_CACHE_H
#define ENGINE_RENDER_CACHE_H

#include <System/Object.h>

namespace Ge
{

class Renderer;

// Every mesh contains a pointer to a RenderCache. The RenderCache contains
// a Renderer dependent representation of geometry data. Rendering the cache
// is a lot faster than rendering the original mesh. When geometry changes, the
// cache should be updated automatically (e.g. when using morphing or skinning).
class RenderCache : public Object
{
public:
    virtual
    bool update() = 0;

    // No Renderer gets passed, since e.g. a DirectXRenderer can
    // only render a DirectXCache.

    virtual
    void render() const = 0;
};


} // namespace Ge

#endif // ENGINE_RENDER_CACHE_H