//------------------------------------------------------------------------------
// (c) Aug-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "LocatorTest.h"

#include <Engine/Locator.h>

#include <System/Base.h>

namespace Ge
{

//------------------------------------------------------------------------------
void LocatorTest::run() const
//------------------------------------------------------------------------------
{
    Locator* l0 = GE_NEW Locator("l0");
    Locator* l1 = GE_NEW Locator("l1");
    Locator* l2 = GE_NEW Locator("l2");
    Locator* l3 = GE_NEW Locator("l3");

    l0->addChild(*l1);
    l1->addChild(*l2);
    l0->addChild(*l3);

    Locator::Iterator it = l0->getBegin();
    GE_ASSERT(it->getName() == "l0");
    ++it;
    GE_ASSERT(it->getName() == "l1");
    ++it;
    GE_ASSERT(it->getName() == "l2");
    ++it;
    GE_ASSERT(it->getName() == "l3");
    ++it;
    GE_ASSERT(it == l0->getEnd());
}

} // namespace Ge
