#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 06-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include <Engine/Texture.h>

namespace Ge
{

//------------------------------------------------------------------------------
Texture::Texture(const char* name, Texture::Filtering filtering) :
//------------------------------------------------------------------------------
mName(name),
mFiltering(filtering)
{
}

//------------------------------------------------------------------------------
const std::string& Texture::getName() const
//------------------------------------------------------------------------------
{
    return mName;
}

//------------------------------------------------------------------------------
Texture::Filtering Texture::getFiltering() const
//------------------------------------------------------------------------------
{
    return mFiltering;
}

//------------------------------------------------------------------------------
void Texture::setFormat(Texture::Format format)
//------------------------------------------------------------------------------
{
    mFormat = format;
}

//------------------------------------------------------------------------------
Texture::Format Texture::getFormat() const
//------------------------------------------------------------------------------
{
    return mFormat;
}

//------------------------------------------------------------------------------
bool Texture::hasAlpha() const
//------------------------------------------------------------------------------
{
    return mFormat == BGRA_8888;
}


} // namespace Ge

