//------------------------------------------------------------------------------
// (c) 06-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef ENGINE_TEXTURE_H
#define ENGINE_TEXTURE_H

#include <System/Object.h>

namespace Ge
{

class Renderer;
class Image;

class Texture : public Object
{
public:
    enum Format
    {
        BGRX_8888,
        BGRA_8888
        // Add 8/16 bit textures later
    };

    enum Filtering
    {
        POINT,
        BILINEAR,
        FILTER_DEFAULT = BILINEAR
    };

    enum Addressing
    {
        WRAP,
        MIRROR,
        CLAMP,
        BORDER,
        ADDR_DEFAULT = WRAP
    };

    const std::string& getName() const;

    Filtering getFiltering() const;

    Format getFormat() const;

    bool hasAlpha() const;

    virtual
    Image* convertToImage() const = 0;
    
protected:
    Texture(const char* name, Filtering = FILTER_DEFAULT);
    void setFormat(Format);

private:
    std::string mName;
    Filtering mFiltering;
    Format mFormat;
};

} // namespace Ge

#endif // ENGINE_TEXTURE_H