#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 06-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include <Engine/TexturePool.h>

namespace Ge
{

//------------------------------------------------------------------------------
Pointer<TexturePool>& TexturePool::instancePtr()
//------------------------------------------------------------------------------
{
    static Pointer<TexturePool> tp(0);
    return tp;
}

//------------------------------------------------------------------------------
TexturePool::TexturePool(Texture::Filtering filter) :
//------------------------------------------------------------------------------
mDefaultFiltering(filter)
{
}

//------------------------------------------------------------------------------
void TexturePool::setDefaultFiltering(Texture::Filtering filter)
//------------------------------------------------------------------------------
{
    mDefaultFiltering = filter;
}

//------------------------------------------------------------------------------
Texture::Filtering TexturePool::getDefaultFiltering() const
//------------------------------------------------------------------------------
{
    return mDefaultFiltering;
}

//------------------------------------------------------------------------------
void TexturePool::clear(const char* name)
//------------------------------------------------------------------------------
{
    mTextures.erase(std::string(name));
}

} // namespace Ge
