//------------------------------------------------------------------------------
// (c) 06-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef ENGINE_VECTOR3_KEY_H
#define ENGINE_VECTOR3_KEY_H

#include <System/Timer.h>
#include <Engine/AnimationKey.h>
#include <Math/Vector.h>

namespace Ge
{

// An animation key that stores a Vector3 value
// (used for position, rotation and scale keys)
class Vector3Key : public AnimationKey
{
public:    
    void setValue(const Vector3&);
    void setTangentIn(const Vector3&);   
    void setTangentOut(const Vector3&);

    const Vector3& getValue() const;
    const Vector3& getTangentIn() const;
    const Vector3& getTangentOut() const;

private:
    // Value at the key's time
    Vector3 mValue;

    // Incoming and outgoing gradient vectors at the key's time
    Vector3 mTangentIn;
    Vector3 mTangentOut;
};

} // namespace Ge

#endif // ENGINE_VECTOR3_KEY_H