#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 04-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include "World.h"
#include "Camera.h"
#include "Locator.h"
#include "Link.h"
#include "Cluster.h"
#include "Light.h"

namespace Ge
{

//------------------------------------------------------------------------------
World::World()
//------------------------------------------------------------------------------
{
}

//------------------------------------------------------------------------------
World::~World()
//------------------------------------------------------------------------------
{
}

//------------------------------------------------------------------------------
Camera* World::getCamera() const
//------------------------------------------------------------------------------
{
    return mCamera;
}

//------------------------------------------------------------------------------
void World::setCamera(Camera* camera)
//------------------------------------------------------------------------------
{
    mCamera = camera;
}

//------------------------------------------------------------------------------
void World::add(Mesh& mesh)
//------------------------------------------------------------------------------
{
    Locator* dummy = GE_NEW Locator;
    dummy->get() = Matrix3x4::IDENTITY();
    dummy->update();
    Link* link = GE_NEW Link(*dummy, mesh);
    add(*link);
}

//------------------------------------------------------------------------------
void World::add(Link& link)
//------------------------------------------------------------------------------
{
    mLinks.push_back(Pointer<Link>(&link));
}


//------------------------------------------------------------------------------
void World::add(const Cluster& cluster)
//------------------------------------------------------------------------------
{
    mClusters.push_back(Pointer<const Cluster>(&cluster));
}

//------------------------------------------------------------------------------
const std::vector<Pointer<const Cluster> >& World::getClusters() const
//------------------------------------------------------------------------------
{
    return mClusters;
}

//------------------------------------------------------------------------------
const std::vector<Pointer<Link> >& World::getLinks() const
//------------------------------------------------------------------------------
{
    return mLinks;
}

//------------------------------------------------------------------------------
void World::add(const Light& l)
//------------------------------------------------------------------------------
{
    mLights.push_back(Pointer<const Light>(&l));
}

//------------------------------------------------------------------------------
const std::vector<Pointer<const Light> >& World::getLights() const
//------------------------------------------------------------------------------
{
    return mLights;
}

} // namespace Ge