//------------------------------------------------------------------------------
// (c) 04-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef ENGINE_WORLD_TRANSFORM_H
#define ENGINE_WORLD_TRANSFORM_H

#include <Math/Vector.h>
#include <Math/Matrix.h>

namespace Ge
{

// THIS IS DEPRECATED. I'LL REMOVE IT LATER.

// This class was added when non uniform scaling was introduced. Because
// then a LocalTransform multiplied by a LocalTransform couldn't be represented
// as a LocalTransform anymore (the scale vector can't be deduced from the
// product). So a WorldTransform is the matrix part of a transform and the
// translation.
class WorldTransform
{
public:
    // Sets to identity transform
    WorldTransform();
    
    const Vector3& getTranslation() const;
    const Matrix3x3& getMatrix3x3() const;
    
    const Float& getScale() const;
    
    // Tools
    // Combines a WorldTransform: <first> will be applied first, <second> will
    // be applied afterwards. (Normally <first> is a node's local transform as
    // a world transform (by toWorldTransform()) and <second> the parent's
    // world transform.)
    // <first> may be *this!
    void multiply(const WorldTransform& second, const WorldTransform& first);
    void getMatrix4x4(Matrix4x4& matrix) const;

private:
    friend class LocalTransform;

    Float mScale;
    Vector3 mTranslation;
    Matrix3x3 mMatrix;
};

} // namespace Ge

#endif // ENGINE_WORLD_TRANSFORM_H