#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include <Input/Button.h>

#include <System/Base.h>

#include <Application/Metronome.h>

#include <iostream>

namespace Ge
{

//------------------------------------------------------------------------------
Button::Button() :
//------------------------------------------------------------------------------
mPressed(false),
mPressedLastUpdate(false),
mLastUpdate(0)
{
}

//------------------------------------------------------------------------------
Button::~Button()
//------------------------------------------------------------------------------
{
}

//------------------------------------------------------------------------------
void Button::override()
//------------------------------------------------------------------------------
{
}

//------------------------------------------------------------------------------
bool Button::isPressed() const
//------------------------------------------------------------------------------
{
    return mPressed;
}

//------------------------------------------------------------------------------
void Button::update()
//------------------------------------------------------------------------------
{
    if (mLastUpdate != theMetronome().getUpdateCount())
    {
        mPressedLastUpdate = mPressed;
        mPressed = false;
        implementUpdate();

        mLastUpdate = theMetronome().getUpdateCount();

        // Call this because some keys override their component keys'
        // pressed state (e.g. if a ALT+LEFT is pressed for strafing, then it
        // cancels the LEFT key's pressed state).
        override();
    }
}

//------------------------------------------------------------------------------
bool Button::isButtonDown() const
//------------------------------------------------------------------------------
{
    return (!mPressedLastUpdate) && mPressed;
}

//------------------------------------------------------------------------------
bool Button::isButtonUp() const
//------------------------------------------------------------------------------
{
    return mPressedLastUpdate && !mPressed;
}

} // namespace Ge