#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include "ComboButton.h"

#include <Application/Metronome.h>

namespace Ge
{

//------------------------------------------------------------------------------
ComboButton::ComboButton(Button& first, Timer::Unit tolerance) :
//------------------------------------------------------------------------------
mTolerance(tolerance),
mFirstPress(0),
mPendingKey(0)
//mPressed(false)
{
    add(first);
}

//------------------------------------------------------------------------------
void ComboButton::add(Button& button)
//------------------------------------------------------------------------------
{
    mKeys.push_back(&button);
}

//------------------------------------------------------------------------------
void ComboButton::implementUpdate()
//------------------------------------------------------------------------------
{
    mPressed = false;
    Timer::Unit time = theMetronome().getAbsolute();

    // Check tolerance
    if ((time - mFirstPress) > mTolerance)
    {
        mFirstPress = 0;
        mPendingKey = 0;
    }

    // Check next key in sequence
    mKeys[mPendingKey]->update();
    if (mKeys[mPendingKey]->isButtonDown())
    {
        mPendingKey++;
        if (mFirstPress == 0)
        {
            mFirstPress = time;
        }
    }

    // Sequence finished?
    if (mPendingKey >= mKeys.size())
    {
        mPressed = true;
        mFirstPress = 0;
        mPendingKey = 0;
    }
}

} // namespace Ge

