#ifndef INPUT_DEVICE_BUTTON_H
#define INPUT_DEVICE_BUTTON_H
#pragma once

//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include "Button.h"
#include "Mouse.h"
#include "Keyboard.h"

namespace Ge
{

// Currently DEVICE is either Keyboard or Mouse. Users should use the
// typedefs provided below.
template<class DEVICE>
class DeviceButton : public Button
{
public:
    
    // For some reason this has to be inline
    DeviceButton(DEVICE::Button b) :
    mButton(b)
    {
    }

private:
    virtual
    void implementUpdate();

    DEVICE::Button mButton;
};

typedef DeviceButton<Keyboard> KeyboardButton;
typedef DeviceButton<Mouse> MouseButton;


template<class DEVICE>
//------------------------------------------------------------------------------
void DeviceButton<DEVICE>::implementUpdate()
//------------------------------------------------------------------------------
{
    mPressed = DEVICE::instance().isPressed(mButton);
}

} // namespace Ge

#endif // INPUT_DEVICE_BUTTON_H