//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef INPUT_INPUT_CONTEXT_H
#define INPUT_INPUT_CONTEXT_H


#include <System/Pointer.h>

#include <Input/MappedCommand.h>

#include <vector>

namespace Ge
{

// An InputContext serves as a collection of MappedCommands. Examples would be
// the actual game context, a menu context, a console context,...
class InputContext
{
public:
    InputContext();
    InputContext(MappedCommand&);

    void update();

    void add(MappedCommand&);

private:
    std::vector<Pointer<MappedCommand> > mCommands;
};


} // namespace Ge

#endif // INPUT_INPUT_CONTEXT_H