#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include <Input/KeyMap.h>

namespace Ge
{

//------------------------------------------------------------------------------
KeyMap& KeyMap::instance()
//------------------------------------------------------------------------------
{
    static KeyMap keyMap;
    return keyMap;
}

//------------------------------------------------------------------------------
void KeyMap::map(DeviceButton::Code code, const char* virtualKey)
//------------------------------------------------------------------------------
{
    unMap(code);
    mMap[code] = std::string(virtualKey);
}

//------------------------------------------------------------------------------
void KeyMap::unMap(DeviceButton::Code code)
//------------------------------------------------------------------------------
{
    mMap.erase(code);
}

//------------------------------------------------------------------------------
const std::string& KeyMap::get(DeviceButton::Code code) const
//------------------------------------------------------------------------------
{
    static std::string unmapped("UNMAPPED");
    Map::const_iterator it = mMap.find(code);
    return it == mMap.end() ? unmapped : it->second;
}

//------------------------------------------------------------------------------
KeyMap::KeyMap()
//------------------------------------------------------------------------------
{
}

} // namespace Ge