//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef INPUT_KEY_MAP
#define INPUT_KEY_MAP

#include <Input/DeviceButton.h>
#include <map>

namespace Ge
{

#define theKeyMap KeyMap::instance()

// When the key bindings are read from the .set file they are entered here
class KeyMap
{
public:
    static
    KeyMap& instance();

    void map(DeviceButton::Code, const char* virtualKey);
    void unMap(DeviceButton::Code);
    const std::string& get(DeviceButton::Code) const;

private:
    KeyMap();
    typedef std::map<DeviceButton::Code, std::string> Map;
    Map mMap;
};

} // namespace Ge

#endif // INPUT_KEY_MAP

