#include "Precompiled.h"
#include <Input/MappedCommand.h>
#include <Application/Command.h>


namespace Ge
{

//------------------------------------------------------------------------------
MappedCommand::MappedCommand(Command& command, Button& key, bool continuous) :
//------------------------------------------------------------------------------
mCommand(&command),
mContinuous(continuous),
mKey(&key)
{
}

//------------------------------------------------------------------------------
const std::string MappedCommand::getString() const
//------------------------------------------------------------------------------
{
    return mCommand->getString();
}

//------------------------------------------------------------------------------
void MappedCommand::update()
//------------------------------------------------------------------------------
{
    mKey->update();
}

//------------------------------------------------------------------------------
bool MappedCommand::execute()
//------------------------------------------------------------------------------
{
    bool run(false);
    if ((mContinuous && mKey->isPressed()) ||
        (!mContinuous && mKey->isButtonDown()))
        run = true;

    if (run)
        mCommand->execute();

    return run;
}

} // namespace Ge


