#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include <Input/ModButton.h>
#include <Input/DeviceButton.h>

namespace Ge
{

//------------------------------------------------------------------------------
ModButton::ModButton(Button& primary, Button& modifier) :
//------------------------------------------------------------------------------
mPrimary(&primary),
mModifier(&modifier)
{
}

//------------------------------------------------------------------------------
void ModButton::implementUpdate()
//------------------------------------------------------------------------------
{
    mPrimary->update();
    mModifier->update();

    mPressed = mPrimary->isPressed() && mModifier->isPressed();
}

//------------------------------------------------------------------------------
void ModButton::override()
//------------------------------------------------------------------------------
{
    // If isTickPressed() then reset the primary key so its command
    // isn't executed
    if (isPressed())
    {
        mPrimary->mPressed = false;
    }
}

} // namespace Ge


