//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef INPUT_MOD_BUTTON_H
#define INPUT_MOD_BUTTON_H

#include <System/Pointer.h>
#include <Input/Button.h>

namespace Ge
{

// A ModButton represents a pair of keys with one primary key and a modifier
// key. The keypresses of the primary key are only valid if the modifier
// is pressed.
// Primary and modifier are not deleted on destruction.
class ModButton : public Button
{
public:
    ModButton(Button& primary, Button& modifier);

protected:
    virtual
    void implementUpdate();

    virtual
    void override();

private:
    Button* mPrimary;
    Button* mModifier;
};

} // namespace Ge

#endif // INPUT_MOD_BUTTON_H