//------------------------------------------------------------------------------
// (c) 03-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef INPUT_MOUSE_H
#define INPUT_MOUSE_H

#include <Math/Vector.h>

namespace Ge
{

class Mouse
{
public:
    enum Button
    {
        LEFT = 0,
        MIDDLE = 2,
        RIGHT = 1,
        BUTTON_COUNT
    };

    static
    Mouse& instance();

    // Call this once per frame to update the current mouse state
    void update();

    // Returns the absolute mouse position in screen coordinates
    void getAbsolute(Vector2& pos) const;

    // Returns a relative mouse position. I'm not sure of the scale of the
    // returned value yet.
    void getDelta(Vector2& pos) const;

    // Returns the relative mouse wheel movement. If the mouse has no wheel
    // then 0 is returned.
    Float getWheelDelta() const;

    bool isPressed(Button) const;

private:
    Mouse();

    bool mPressed[BUTTON_COUNT];
    Vector2 mDelta;
    Vector2 mAbsolute;
    Float mWheel;
};

inline
//------------------------------------------------------------------------------
Mouse& theMouse()
//------------------------------------------------------------------------------
{
    return Mouse::instance();
}

} // namespace Ge

#endif // INPUT_MOUSE_H