#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include "MultiButton.h"

#include <Application/Metronome.h>

namespace Ge
{

//------------------------------------------------------------------------------
MultiButton::MultiButton(Button& first, Button& second)
//------------------------------------------------------------------------------
{
    add(first);
    add(second);
}

    
//------------------------------------------------------------------------------
void MultiButton::add(Button& button)
//------------------------------------------------------------------------------
{
    mButtons.push_back(&button);
}

//------------------------------------------------------------------------------
void MultiButton::implementUpdate()
//------------------------------------------------------------------------------
{
    UInt i;
    for (i = 0; i<mButtons.size(); i++)
    {
        mButtons[i]->update();
    }

    mPressed = true;
    for (i = 0; i<mButtons.size() && mPressed; i++)
    {
        if (!mButtons[i]->isPressed())
        {
            mPressed = false;
        }
    }
}


//------------------------------------------------------------------------------
void MultiButton::override()
//------------------------------------------------------------------------------
{
    // If isPressed() then reset the single keys so their command
    // isn't executed
    if (isPressed())
    {
        for (UInt i = 0; i<mButtons.size(); i++)
        {
            mButtons[i]->mPressed = false;//reset();
        }
    }
}

} // namespace Ge


