//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef INPUT_MULTI_BUTTON_H
#define INPUT_MULTI_BUTTON_H

#include "Button.h"

#include <vector>
#include <utility>

namespace Ge
{

// MultiButtons are buttons that represent two or more buttons that have to be
// pressed/triggered together. The component buttons are not deleted on destruction.
class MultiButton : public Button
{
public:
    // <first>, <second>: First two buttons of the multibutton.
    MultiButton(Button& first, Button& second);
        
    // Adds <button> to the list of buttons that have to be pressed
    // simultaneously.
    void add(Button& button);

protected:
    virtual
    void implementUpdate();

    // This function is called after the first update path, so that
    // we can cancel the sub keys pressed state
    virtual
    void override();

private:
    std::vector<Button*> mButtons;
};

} // namespace Ge

#endif // INPUT_MULTI_BUTTON_H