#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) Jun-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "RepeatButton.h"

#include <Application/Metronome.h>

namespace Ge
{

//------------------------------------------------------------------------------
RepeatButton::RepeatButton(Button& button) :
//------------------------------------------------------------------------------
mButton(&button),
mDelay(500),
mRate(50),
mWait(0),
mWaitStart(0)
{
}

//------------------------------------------------------------------------------
// Accessors
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
Timer::Unit RepeatButton::getDelay() const
//------------------------------------------------------------------------------
{
    return mDelay;
}

//------------------------------------------------------------------------------
void RepeatButton::setDelay(const Timer::Unit& t)
//------------------------------------------------------------------------------
{
    mDelay = t;
}

//------------------------------------------------------------------------------
Timer::Unit RepeatButton::getRate() const
//------------------------------------------------------------------------------
{
    return mRate;
}

//------------------------------------------------------------------------------
void RepeatButton::setRate(const Timer::Unit& t)
//------------------------------------------------------------------------------
{
    mRate = t;
}

//------------------------------------------------------------------------------
// Protected members
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
void RepeatButton::implementUpdate()
//------------------------------------------------------------------------------
{
    Timer::Unit t = theMetronome().getAbsolute();

    mButton->update();
    mPressed = mButton->isPressed();
    if (mPressed)
    {
        if (mWait == 0)
        {
            mWait = mDelay;
            mWaitStart = t;
        }
        else if (mWait <= t-mWaitStart)
        {
            mWait = mRate;
            mWaitStart = t;
            mPressed = false;
        }
    }
    else
    {
        mWait = 0;
        mWaitStart = 0;
    }
}

} // namespace Ge
