//------------------------------------------------------------------------------
// (c) Mai-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "ComboButtonTest.h"

#include <Input/ComboButton.h>
#include <Input/VirtualButton.h>
#include <Input/DeviceButton.h>

#include <Application/Metronome.h>

#include <iostream>

namespace Ge
{

//------------------------------------------------------------------------------
void ComboButtonTest::run() const
//------------------------------------------------------------------------------
{
    std::cout<<"E = HiKick, D = LoKick, EEDE = Fatality\n";
    KeyboardButton e(Keyboard::E);
    VirtualButton high("high", e);
    
    KeyboardButton d(Keyboard::D);
    VirtualButton low("low", d);

    ComboButton finish(high, 1000);
    finish.add(high);
    finish.add(low);
    finish.add(high);

    UInt counter(0);
    while (counter < 20)
    {
        theMetronome().update();
        theKeyboard().update();

        high.update();
        low.update();
        finish.update();
        
        if (finish.isButtonDown())
        {
            std::cout<<"FINISH HIM\n";
            counter++;
        }

        if (high.isButtonDown())
        {
            std::cout<<"uh\n";
            counter++;
        }

        if (low.isButtonDown())
        {
            std::cout<<"ah\n";
            counter++;
        }
    }
}

} // namespace Ge
