//------------------------------------------------------------------------------
// (c) Mai-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "InputContextTest.h"

#include <Input/InputContext.h>
#include <Input/DeviceButton.h>

#include <Application/Command.h>
#include <Application/Metronome.h>

#include <System/Tools.h>

#include <iostream>

namespace Ge
{

//------------------------------------------------------------------------------
void InputContextTest::run() const
//------------------------------------------------------------------------------
{
    // This typedef is necessary, since MSVC doesn't recognize classes local
    // to a function
    typedef class TestCommand : public Command
    {
    public:
        TestCommand() : Command("TestCommand") {}
        virtual void execute(std::string*)
        {
            std::cout<<(getString() + " was executed\n").c_str();
        }
    } Tc;

    std::cout<<"Press enter\n";
    KeyboardButton enter(Keyboard::ENTER);
    Tc* cmd = GE_NEW TestCommand;
    MappedCommand* mapCmd = GE_NEW MappedCommand(*cmd, enter);

    InputContext context(*mapCmd);

    Timer::Unit testStart = theMetronome().getAbsolute();
    while (theMetronome().getAbsolute() - testStart < 3000)
    {
        theMetronome().update();
        theKeyboard().update();
        context.update();    
    }
}

} // namespace Ge
