//------------------------------------------------------------------------------
// (c) Mai-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "MappedCommandTest.h"

#include <Input/DeviceButton.h>
#include <Input/MappedCommand.h>

#include <string>
#include <iostream>

#include <Application/Command.h>
#include <Application/Metronome.h>

namespace Ge
{

//------------------------------------------------------------------------------
void MappedCommandTest::run() const
//------------------------------------------------------------------------------
{
    // This typedef is necessary, since MSVC doesn't recognize classes local
    // to a function
    typedef class TestCommand : public Command
    {
    public:
        TestCommand() : Command("TestCommand") {}
        virtual void execute(std::string*)
        {
            std::cout<<(getString() + " was executed\n").c_str();
        }
    } Tc;

    std::cout<<"Press enter\n";
    Tc* cmd = GE_NEW TestCommand;
    KeyboardButton enter(Keyboard::ENTER);
    MappedCommand key(*cmd, enter);
    
    UInt count(0);
    while (count<2)
    {
        theMetronome().update();
        theKeyboard().update();
        key.update();

        if (key.execute())
        {
            count++;
        }
    }
}

} // namespace Ge
