//------------------------------------------------------------------------------
// (c) Mai-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "MultiButtonTest.h"

#include <Input/VirtualButton.h>
#include <Input/MultiButton.h>
#include <Input/DeviceButton.h>

#include <Application/Metronome.h>

#include <iostream>


namespace Ge
{

//------------------------------------------------------------------------------
void MultiButtonTest::run() const
//------------------------------------------------------------------------------
{
    std::cout<<"LCtrl = Fire1, LShift = Fire2, Both = Smart Bomb\n";
    
    KeyboardButton lControl(Keyboard::LEFT_CONTROL);
    VirtualButton f1("fire1", lControl);

    KeyboardButton lShift(Keyboard::LEFT_SHIFT);
    VirtualButton f2("fire2", lShift);
    
    MultiButton bomb(f1, f2);

    UInt counter(0);
    while (counter < 10)
    {
        theMetronome().update();
        theKeyboard().update();
        f1.update();
        f2.update();
        bomb.update();
        
        if (bomb.isButtonDown())
        {
            std::cout<<"KABOOOOM\n";
            counter++;
        }

        if (f1.isButtonDown())
        {
            std::cout<<"boom\n";
            counter++;
        }

        if (f2.isButtonDown())
        {
            std::cout<<"peng\n";
            counter++;
        }
    }
}

} // namespace Ge
