//------------------------------------------------------------------------------
// (c) Jun-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "RepeatButtonTest.h"

#include <Input/DeviceButton.h>
#include <Input/RepeatButton.h>

#include <Application/Metronome.h>

#include <iostream>


namespace Ge
{

//------------------------------------------------------------------------------
void RepeatButtonTest::run() const
//------------------------------------------------------------------------------
{
    KeyboardButton space(Keyboard::SPACE);
    RepeatButton repeatSpace(space);

    UInt triggered = 0;
    std::cout<<"Press and hold SPACE\n";
    while (triggered < 50)
    {
        theMetronome().update();
        theKeyboard().update();
        space.update();
        repeatSpace.update();

        if (space.isButtonDown())
        {
            std::cout<<"KeyboardButton triggered\n";
        }

        if (repeatSpace.isButtonDown())
        {
            std::cout<<"RepeatButton triggered\n";
            ++triggered;
        }
    }
}

} // namespace Ge
