#include "Precompiled.h"

//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include "VirtualButton.h"

namespace Ge
{

//------------------------------------------------------------------------------
VirtualButton::VirtualButton(const char* name, Button& key) :
//------------------------------------------------------------------------------
mName(name)
{
    map(key);
}

    
//------------------------------------------------------------------------------
void VirtualButton::map(Button& button)
//------------------------------------------------------------------------------
{
    mButtons.push_back(&button);
}

//------------------------------------------------------------------------------
const std::string VirtualButton::getName() const
//------------------------------------------------------------------------------
{
    return mName;
}


//------------------------------------------------------------------------------
void VirtualButton::implementUpdate()
//------------------------------------------------------------------------------
{
    UInt i;
    for (i = 0; i<mButtons.size(); i++)
    {
        mButtons[i]->update();
    }

    mPressed = false;
    for (i = 0; i<mButtons.size() && !mPressed; i++)
    {
        if (mButtons[i]->isPressed())
        {
            mPressed = true;
        }
    }
}

} // namespace Ge
