//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef INPUT_VIRTUAL_BUTTON_H
#define INPUT_VIRTUAL_BUTTON_H

#include <Input/Button.h>

#include <vector>
#include <string>

namespace Ge
{

// VirtualButtons are mapped Buttons. The mapped buttons will not be
// deleted on destruction.
class VirtualButton : public Button
{
public:
    VirtualButton(const char* name, Button& key);

    void map(Button& key); 

    // Returns the name of the command associated with this MappedCommand
    const std::string getName() const;

protected:
    virtual
    void implementUpdate();


private:
    std::string mName;
    std::vector<Button*> mButtons;
};

} // namespace Ge

#endif // INPUT_VIRTUAL_BUTTON_H

