//------------------------------------------------------------------------------
// (c) 02-2002 Gottfried Chen
//------------------------------------------------------------------------------

namespace Ge
{

template<class T> inline
//------------------------------------------------------------------------------
MyFft<T>::MyFft(unsigned int sizePower, int sign) :
//------------------------------------------------------------------------------
mSizePower(sizePower),
mSign(sign)
{
}

template<class T> inline
//------------------------------------------------------------------------------
void MyFft<T>::calculate(std::complex<T>* data) const
//------------------------------------------------------------------------------
{
    FftRoutines<T>::fft(data, mSizePower, mSign);
}

template<class T> inline
//------------------------------------------------------------------------------
MyFft2D<T>::MyFft2D(unsigned int xSizePower, unsigned int ySizePower, int sign) :
//------------------------------------------------------------------------------
mXSizePower(xSizePower),
mYSizePower(ySizePower),
mSign(sign)
{
}

template<class T> inline
//------------------------------------------------------------------------------
void MyFft2D<T>::calculate(std::complex<T>* data) const
//------------------------------------------------------------------------------
{
    FftRoutines<T>::fft2D(data, mYSizePower, mXSizePower, mSign);
}

} // namespace Ge