//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef MATH_HALF_SPACE_H
#define MATH_HALF_SPACE_H

#include "Plane.h"
#include "Intersection.h"

namespace Ge
{

// A plane describes a half space, where the normal points inside the space.
// That half space defines the way containment is seen. The half space is
// topologically closed (i.e. the plane itself is contained in the space).
class HalfSpace
{
public:
    // Sets to XY-plane, with normal (0,0,1)
    HalfSpace();
    HalfSpace(const Plane&);

    Intersect::Type intersects(const Sphere&) const;
    bool contains(const Vector3&) const;

    void set(const Plane&);
    const Plane& getPlane() const;

private:
    Plane mPlane;
};

} // namespace Ge

#endif // MATH_HALF_SPACE_H