//------------------------------------------------------------------------------
// (c) 06-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef MATH_HERMITE_INTERPOLATOR_H
#define MATH_HERMITE_INTERPOLATOR_H

#include <Math/Interpolator.h>

namespace Ge
{

// Interpolation using Hermite splines. (### Maybe TCB splines - which actually
// are just modified Hermite splines - will be implemented later in a
// TcbInterpolator class, but since Lightwave exports the tangents there is no need
// for that yet.)
class HermiteInterpolator : public Interpolator
{
public:
    // See <Math/Interpolation.h> for a description. Use toUnitInterval() if
    // your interpolation interval is not (0,1).
    virtual
    Float interpolate(const Float& f0, const Float& f1,
                      const Float& df0, const Float& df1,
                      const Float& s) const;
};

} // namespace Ge

#endif // MATH_HERMITE_INTERPOLATOR_H
