//------------------------------------------------------------------------------
// (c) Aug-2002 Gottfried Chen
//------------------------------------------------------------------------------

namespace Ge
{

template<typename T, UInt DIM> inline
//------------------------------------------------------------------------------
void lerp(BasicVector<T, DIM>& result, const BasicVector<T, DIM>& f0,
          const BasicVector<T, DIM>& f1, Float s)
//------------------------------------------------------------------------------
{
    GE_ASSERT(0<=s && s<=1);
    result = f0 != f1 ? f0*(1-s) + f1*s : f0;
}

template<typename T, UInt R, UInt C> inline
//------------------------------------------------------------------------------
void lerp(BasicMatrix<T, R, C>& result, const BasicMatrix<T, R, C>& f0,
          const BasicMatrix<T, R, C>& f1, Float s)
//------------------------------------------------------------------------------
{
    GE_ASSERT(0<=s && s<=1);
    for (UInt r = 0; r<R; ++r)
    {
        for (UInt c = 0; c<C; ++c)
        {
            result(r, c) = f0(r, c)*(1-s) + f1(r, c)*s;
        }
    }
}

} // namespace Ge
