//------------------------------------------------------------------------------
// (c) 06-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef MATH_INTERPOLATOR_H
#define MATH_INTERPOLATOR_H

#include <System/Types.h>
#include <System/Object.h>

namespace Ge
{

// Interpolators can be used for e.g. configuring key frame animation.
// Changing the interpolator will affect how smooth the animation will
// look like.
class Interpolator : public Object
{
public:
    // See <Math/Interpolation.h> hermite() for a parameter description.
    // Use toUnitInterval() if your interpolation interval is not (0,1).
    virtual
    Float interpolate(const Float& f0, const Float& f1,
                      const Float& df0, const Float& df1,
                      const Float& s) const = 0;
};

} // namespace Ge

#endif // MATH_INTERPOLATOR_H