#ifndef MATH_INTERSECTION_H
#define MATH_INTERSECTION_H
#pragma once

//------------------------------------------------------------------------------
// (c) Jun-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "Vector.h"

namespace Ge
{

class Plane;
class Ray;

// This enum is returned by diverse intersection tests
namespace Intersect
{
    // Attention: Don't change the ordering of this enum! Some functions
    // depend on it being this way. Further since DISJOINT = 0 you can
    // use e.g. if (intersects(a, b)), if you are only interested if any
    // intersection has occured and don't care about containment.
    enum Type
    {
        DISJOINT = 0,
        INTERSECTS,
        CONTAINS
    };
}

// If Intersect::INTERSECTS is returned then <point>
// contains the intersection point.
Intersect::Type intersects(const Plane&, const Ray&, Vector3* point = 0);

Intersect::Type intersects(const Ray&, const Plane&, Vector3* point = 0);

} // namespace Ge

#endif // !MATH_INTERSECTION_H