#include "Precompiled.h"

//------------------------------------------------------------------------------
// (c) 01-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include <System/Assert.h>
#include "Interval.h"

#include <algorithm>

namespace Ge
{

//------------------------------------------------------------------------------
Interval::Interval(float left, float right) :
//------------------------------------------------------------------------------
mLeft(left),
mRight(right)
{
    GE_ASSERT(left<=right);
    if (left>right)
        std::swap(left, right);
}

//------------------------------------------------------------------------------
float Interval::getDistance(float val) const
//------------------------------------------------------------------------------
{
    if (val < mLeft)
        return mLeft - val;
    else if (val > mRight)
        return val - mRight;
    else
        return 0;
}

//------------------------------------------------------------------------------
bool Interval::contains(float val) const
//------------------------------------------------------------------------------
{
    return mLeft<=val && val<=mRight;
}

//------------------------------------------------------------------------------
float Interval::getLeft() const
//------------------------------------------------------------------------------
{
    return mLeft;
}

//------------------------------------------------------------------------------
float Interval::getRight() const
//------------------------------------------------------------------------------
{
    return mRight;
}

//------------------------------------------------------------------------------
void Interval::set(float left, float right)
//------------------------------------------------------------------------------
{
    mLeft = left;
    mRight = right;
}

} // namespace Ge
