//------------------------------------------------------------------------------
// (c) 01-2002 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef INTERVAL_H
#define INTERVAL_H

namespace Ge
{

// Represents a closed interval
class Interval
{
public:
    Interval(float left = 0, float right = 0);

    // Returns the absolute distance (= 0 if inside, any other positive value
    // if either left or right from the borders)
    float getDistance(float) const;  

    // Returns true if <value> is contained in the interval.
    bool contains(float value) const;

    void set(float left, float right);

    float getLeft() const;

    float getRight() const;

private:
    float mLeft;
    float mRight;
};

} // namespace Ge

#endif // INTERVAL_H