//------------------------------------------------------------------------------
// (c) 06-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef MATH_LINEAR_INTERPOLATOR_H
#define MATH_LINEAR_INTERPOLATOR_H

#include <Math/Interpolator.h>

namespace Ge
{

// Interpolates linearly between <f0> and <f1>. So the tangent values are
// actually discarded.
class LinearInterpolator : public Interpolator
{
public:
    // See <Math/Interpolation.h> for a description. Use toUnitInterval() if
    // your interpolation interval is not (0,1).
    virtual
    Float interpolate(const Float& f0, const Float& f1,
                      const Float& df0, const Float& df1,
                      const Float& s) const;
};

} // namespace Ge

#endif // MATH_LINEAR_INTERPOLATOR_H