#include "Precompiled.h"

//------------------------------------------------------------------------------
// (c) 01-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "Random.h"
#include "Math.h"

namespace Ge
{

//------------------------------------------------------------------------------
Float frand(Float min, Float max)
//------------------------------------------------------------------------------
{
    return min+(Float(::rand())/Float(RAND_MAX))*(max-min);
}

//------------------------------------------------------------------------------
Int rand(Int min, Int max)
//------------------------------------------------------------------------------
{
    return min + (::rand()%(max-min+1));
}

//------------------------------------------------------------------------------
Float gaussian()
//------------------------------------------------------------------------------
{
    static Float y1, y2;
    static bool calculate(true);
    Float x1, x2, w;

    if (calculate)
    {
        calculate = false;

        do
        {
            x1 = 2.0f*frand(0, 1) - 1.0f;
            x2 = 2.0f*frand(0, 1) - 1.0f;
            w = x1*x1 + x2*x2;
        } while (w >= 1.0f);

        w = sqrt((-2.0f*log(w))/w);
        y1 = x1*w;
        y2 = x2*w;
        
        return y1;
    }
    else
    {
        calculate = true;
        return y2;
    }
}

} // namespace Ge