#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) Jun-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "Ray.h"

namespace Ge
{

//------------------------------------------------------------------------------
Ray::Ray()
//------------------------------------------------------------------------------
{
}

//------------------------------------------------------------------------------
Ray::Ray(const Vector3& start, const Vector3& direction)
//------------------------------------------------------------------------------
{
    setStart(start);
    setDirection(direction);
}

//------------------------------------------------------------------------------
void Ray::setStart(const Vector3& s)
//------------------------------------------------------------------------------
{
    mStart = s;
}

//------------------------------------------------------------------------------
const Vector3& Ray::getStart() const
//------------------------------------------------------------------------------
{
    return mStart;
}

//------------------------------------------------------------------------------
void Ray::setDirection(const Vector3& d)
//------------------------------------------------------------------------------
{
    GE_ASSERT(!d.isAlmost(Vector3::ORIGIN()));
    mDirection = d;
}

//------------------------------------------------------------------------------
const Vector3& Ray::getDirection() const
//------------------------------------------------------------------------------
{
    return mDirection;
}

//------------------------------------------------------------------------------
std::ostream& operator <<(std::ostream& os, const Ray& r)
//------------------------------------------------------------------------------
{
    os << '(' << "start: " << r.getStart() << ", direction: " << r.getDirection()
       << ')';

    return os;
}

} // namespace Ge
