#ifndef MATH_RAY_H
#define MATH_RAY_H
#pragma once

//------------------------------------------------------------------------------
// (c) Jun-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "Vector.h"

#include <iosfwd>

namespace Ge
{

class Plane;

// The direction of a ray must not be (0,0,0)
class Ray
{
public:
    // Doesn't do anything.
    Ray();

    Ray(const Vector3& start, const Vector3& direction);

    void setStart(const Vector3&);

    const Vector3& getStart() const;

    void setDirection(const Vector3&);

    const Vector3& getDirection() const;

private:
    Vector3 mStart;
    Vector3 mDirection;
};

std::ostream& operator <<(std::ostream&, const Ray&);

} // namespace Ge

#endif // !MATH_RAY_H