//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef MATH_SPHERE_H
#define MATH_SPHERE_H

#include <Math/Vector.h>

namespace Ge
{

// ### Could make this into a template class HyperSphere, but it's not really
// necessary
class Sphere
{
public:
    explicit
    Sphere(const Vector3& center = Vector3::ORIGIN(), const Float& radius = 0);

    bool intersects(const Sphere&) const;
    bool contains(const Vector3&) const;
    bool contains(const Sphere&) const;

    const Vector3& getCenter() const;
    void setCenter(const Vector3&);

    const Float& getRadius() const;
    void setRadius(const Float&);

    void merge(const Sphere&);
    void merge(const Vector3&, UInt vertexCount);

private:
    Vector3 mCenter;
    Float mRadius;
};

} // namespace Ge

#endif // MATH_SPHERE_H