//------------------------------------------------------------------------------
// (c) Mai-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "InterpolationTest.h"

#include <Math/Interpolation.h>

#include <System/Assert.h>

namespace Ge
{

//------------------------------------------------------------------------------
void InterpolationTest::run() const
//------------------------------------------------------------------------------
{
    Float t0(23), t1(31), t(27);
    Float s(toUnitInterval(t0, t1, t));
    GE_ASSERT(0<=s && s<=1);

    Float f0(2), f1(-3.5f), df0(3.141f), df1(-2.5f);
    GE_ASSERT(lerp(f0, f1, 0) == f0);
    GE_ASSERT(lerp(f0, f1, 1) == f1);
    GE_ASSERT(hermite(f0, f1, df0, df1, 0) == f0);
    GE_ASSERT(hermite(f0, f1, df0, df1, 1) == f1);
}

} // namespace Ge
