//------------------------------------------------------------------------------
// (c) 01-2002 Gottfried Chen
//------------------------------------------------------------------------------

namespace Ge
{

template<class T> inline
//------------------------------------------------------------------------------
UnitRoot<T>::UnitRoot(unsigned int n) :
//------------------------------------------------------------------------------
mN(n)
{
    mPowers = GE_NEW std::complex<T>[n];
    for (unsigned int i = 0; i<n; ++i)
    {
        mPowers[i] = std::complex<T>(cos(TWO_PI*T(i)/T(n)),
                                     sin(TWO_PI*T(i)/T(n)));
    }
}

template<class T> inline
//------------------------------------------------------------------------------
UnitRoot<T>::~UnitRoot()
//------------------------------------------------------------------------------
{
    GE_DELETE_A mPowers;
}

template<class T> inline
//------------------------------------------------------------------------------
const std::complex<T>& UnitRoot<T>::pow(unsigned int p) const
//------------------------------------------------------------------------------
{
    GE_ASSERT(0<=p && p<=mN);
    return mPowers[p];
}

template<class T> inline
//------------------------------------------------------------------------------
UnitRoot<T>::operator const std::complex<T>&() const
//------------------------------------------------------------------------------
{
    return pow(1);
}

} // namespace Ge