//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include <Physics/MassPoint.h>

namespace Ge
{

//------------------------------------------------------------------------------
MassPoint::MassPoint(const Float& mass,
                     const Vector3& position,
                     const Vector3& velocity,
                     const Vector3& acceleration) :
//------------------------------------------------------------------------------
mMass(mass),
mPos(position),
mV(velocity),
mA(acceleration)
{
}


//------------------------------------------------------------------------------
void MassPoint::move(Timer::Unit time)
//------------------------------------------------------------------------------
{
    mV += Float(time)*mA;
    mPos += Float(time)*mV;
}

} // namespace Ge