//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef PHYSICS_MASS_POINT_H
#define PHYSICS_MASS_POINT_H

#include <Math/Vector.h>
#include <System/Timer.h>

namespace Ge
{

class MassPoint
{
public:
    // Velocity and accelaration are distance/second
    MassPoint(const Float& mass,
              const Vector3& position,
              const Vector3& velocity,
              const Vector3& acceleration);

    // Pass <time> in seconds
    void move(Timer::Unit time);

    const Float& getMass() const;
    void setMass(const Float&);
    
    const Vector3& getPosition() const;
    void setPosition(const Vector3&);
    
    const Vector3& getVelocity() const;
    void setVelocity(const Vector3&);
    
    const Vector3& getAcceleration() const;
    void setAcceleration(const Vector3&);
    
private:
    Float mMass;
    Vector3 mPos;    
    Vector3 mV;
    Vector3 mA;
};

} // namespace Ge

#include <Physics/MassPoint.inl>
#endif // PHYSICS_MASS_POINT_H

