//------------------------------------------------------------------------------
// (c) 03-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef SYSTEM_ASSERT_H
#define SYSTEM_ASSERT_H

#include <System/Types.h>

//------------------------------------------------------------------------------
// Assertion macros
//------------------------------------------------------------------------------
// GE_ASSERT is similar to the normal assert macro
// GE_ASSERT_MSG can be supplied with an additional message printed when the
// assert fails
// GE_CTASSERT lets you assert conditions known at compile time

#ifdef NDEBUG

#   define GE_ASSERT(x)

#   define GE_ASSERT_MSG(x, y)

#   define GE_CTASSERT(x)
   
#else // NDEBUG

#   define GE_ASSERT(x) Ge::geAssert((x), (#x), __FILE__, __LINE__)

#   define GE_ASSERT_MSG(x, y) Ge::geAssert((x), (y), __FILE__, __LINE__)
    
    template<bool> class __COMPILE_TIME_ASSERT_FAILED__;
    template<> class __COMPILE_TIME_ASSERT_FAILED__<true> {};
#   define GE_CTASSERT(x) __COMPILE_TIME_ASSERT_FAILED__<x>();

#endif // NDEBUG

namespace Ge
{

void geAssert(bool expression, const char* message, const char* file, UInt line);

} // namespace Ge


#endif // SYSTEM_ASSERT_H