#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) Jun-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "FileSystem.h"

#include "FilePath.h"
#include "Log.h"

#include <direct.h>
#include <iostream>


namespace
{
    struct Init
    {
        Init()
        {
            Ge::theFileSystem();
        }
    } init;

} // namespace


namespace Ge
{

//------------------------------------------------------------------------------
FileSystem::FileSystem()
//------------------------------------------------------------------------------
{
    char buffer[_MAX_PATH];
    bool ok = _getcwd(buffer, _MAX_PATH) != 0;
    GE_ASSERT_MSG(ok, "Couldn't retrieve application path.");
    if (ok)
    {
        mApplicationPath = FilePath(buffer).get() + '/';
        GE_LOG_INFO("Application path: "<<mApplicationPath<<std::endl);
    }
}

//------------------------------------------------------------------------------
const std::string& FileSystem::getApplicationPath() const
//------------------------------------------------------------------------------
{
    return mApplicationPath;
}

} // namespace Ge
