//------------------------------------------------------------------------------
// (c) 03-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef SYSTEM_LOG_H
#define SYSTEM_LOG_H

#include <iosfwd>
#include <System/FilePath.h>

#ifndef NDEBUG
#   define GE_LOG_DEBUG(msg) ::Ge::Log::global().log(::Ge::Log::DEBUG) \
                          <<FilePath(__FILE__).getName()<<": "<<msg
#else
#   define GE_LOG_DEBUG(msg)
#endif

#define GE_LOG_INFO(msg) ::Ge::Log::global().log(::Ge::Log::INFO)<<msg
#define GE_LOG_ERROR(msg) ::Ge::Log::global().log(::Ge::Log::ERR)<<msg

namespace Ge
{

// Logging class, for normal logging use globalLog()
class Log
{
public:
    enum Level
    {
        DEBUG,
        INFO,
        ERR // ERROR is a windows #define
    };

    explicit
    Log(std::ostream& stream);

    std::ostream& log(Level level) const;

    static
    Log& global();

private:
    std::ostream& mStream;
};


} // namespace Ge

#endif // SYSTEM_LOG_H