//------------------------------------------------------------------------------
// (c) 03-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef SYSTEM_OBJECT_H
#define SYSTEM_OBJECT_H

#include <System/Base.h>

namespace Ge
{

// Object provides reference counting for all classes
// derived from it
class Object
{
public:
    Object();
    Object(const Object&);
    virtual ~Object();

private:
    void reference() const;
    void dereference() const;

    friend class PointerBase;

    mutable Int mReferenceCount;
};

} // namespace Ge

#include <System/Object.inl>
#endif // SYSTEM_OBJECT_H