#include "Precompiled.h"

//------------------------------------------------------------------------------
// (c) 05-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include <System/TagLine.h>
#include <System/Assert.h>
#include <System/StringTools.h>

namespace Ge
{

//------------------------------------------------------------------------------
void TagLine::read(std::istream& file)
//------------------------------------------------------------------------------
{
    GE_ASSERT(!file.eof());
    std::string buffer;
    std::getline(file, buffer);
    StringTools::split(buffer, mTag, mRest);
}

//------------------------------------------------------------------------------
void TagLine::read(const std::string& line)
//------------------------------------------------------------------------------
{
    StringTools::split(line, mTag, mRest);
}

//------------------------------------------------------------------------------
const std::string& TagLine::getTag() const
//------------------------------------------------------------------------------
{
    return mTag;
}

//------------------------------------------------------------------------------
const std::string& TagLine::getRest() const
//------------------------------------------------------------------------------
{
    return mRest;
}

//------------------------------------------------------------------------------
void TagLine::split()
//------------------------------------------------------------------------------
{
    StringTools::split(mRest, mTag, mRest);
}

//------------------------------------------------------------------------------
void TagLine::clear()
//------------------------------------------------------------------------------
{
    mTag = "";
    mRest = "";
}

} // namespace Ge