#ifndef SYSTEM_TAG_LINE_H
#define SYSTEM_TAG_LINE_H

#include <string>
#include <fstream>

namespace Ge
{

// This class should facilitate reading of files that contain
// lines like "tag1 tag2 tag3 ...". Quite a lot of code deals with
// reading such lines and should be refactored, but I'm too lazy to
// do that right now.
class TagLine
{
public:
    void read(std::istream& file);
    void read(const std::string& line);

    const std::string& getTag() const;
    const std::string& getRest() const;
    
    void split();
    void clear();

private:
    std::string mTag;
    std::string mRest;
};

} // namespace Ge

#endif // SYSTEM_TAG_LINE_H