//------------------------------------------------------------------------------
// (c) Apr-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "ByteOrderTest.h"

#include <System/ByteOrder.h>

#include <iostream>

namespace Ge
{

//------------------------------------------------------------------------------
void ByteOrderTest::run() const
//------------------------------------------------------------------------------
{
    // Print local byte order
    std::cout<<"Local byte order is"<<
        (theByteOrder.local() == ByteOrder::BIG_ENDIAN ?
         " big endian. " :
         " little endian. ");

    // Test conversions
    short a = 0x000a;
    short b = a;
    theByteOrder.convert(b, theByteOrder.local(), theByteOrder.local());
    GE_ASSERT(a == b);
    theByteOrder.convert(b, ByteOrder::LITTLE_ENDIAN, ByteOrder::LSB);
    GE_ASSERT(a == b);
    theByteOrder.convert(b, ByteOrder::MSB, ByteOrder::LSB);
    
    b = a;
    theByteOrder.to(b, theByteOrder.local() == ByteOrder::LITTLE_ENDIAN ?
                    ByteOrder::BIG_ENDIAN : ByteOrder::LITTLE_ENDIAN);
    GE_ASSERT(b == 0x0a00);
    b = a;
    theByteOrder.from(b, theByteOrder.local() == ByteOrder::LITTLE_ENDIAN ?
                      ByteOrder::BIG_ENDIAN : ByteOrder::LITTLE_ENDIAN);
    GE_ASSERT(b == 0x0a00);
}

} // namespace Ge
