//------------------------------------------------------------------------------
// (c) Jun-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "FilePathTest.h"

#include <System/FilePath.h>
#include <System/Assert.h>
#include <System/Trace.h>


namespace Ge
{

//------------------------------------------------------------------------------
void FilePathTest::run() const
//------------------------------------------------------------------------------
{
    {
        FilePath p("d:///hansi\\burli.exe");
        GE_ASSERT(p.getExtension() == ".exe");
        GE_ASSERT(p.getName() == "burli");
        GE_ASSERT(p.getFile() == "burli.exe");
        GE_ASSERT(p.getDirectory() == "d:/hansi/");
    }

    GE_ASSERT(FilePath("otto").get()=="otto");

    {
        FilePath p("d://\\hansi");
        p += "burli";
        p += "file.bat";
        GE_ASSERT(p.get() == "d:/hansi/burli/file.bat");
    }
}

} // namespace Ge
