//------------------------------------------------------------------------------
// (c) Apr-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "StringToolsTest.h"
#include <System/StringTools.h>



namespace Ge
{

//------------------------------------------------------------------------------
void StringToolsTest::run() const
//------------------------------------------------------------------------------
{
    // Test split()
    std::string str0("a b");
    std::string a, b;
    StringTools::split(str0, a, b);
    GE_ASSERT("a" == a);
    GE_ASSERT("b" == b);

    str0 = "\ta b";
    StringTools::split(str0, a, b);
    GE_ASSERT("a" == a);
    GE_ASSERT("b" == b);

    // Test hexToInt()
    std::string str1("  00a1 ");
    GE_ASSERT(161 == StringTools::hexToInt(str1));

    // Test replace()
    {
        std::string s("abc");
        s = StringTools::replace(s, "abc", "d");
        GE_ASSERT(s == "d");

        s = "otto hallo otto hallotto";
        s = StringTools::replace(s, "otto", "franziska");
        GE_ASSERT(s == "franziska hallo franziska hallfranziska");
    }
}

} // namespace Ge

