#ifndef TEST_FRAMEWORK_H
#define TEST_FRAMEWORK_H
#pragma once

//------------------------------------------------------------------------------
// (c) Apr-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include <iostream>

namespace Ge
{

// Call this at the beginning of your testsuite.
void beginTestSuite(const char* name);

// Usage:
// RUN_TEST(TestClass)
//
// TestClass must provide a public member function
// void run()
// that executes the test case.
#define RUN_TEST(x) \
{\
    std::cout<<"Running "<<#x<<": "; \
    x testCase; \
    testCase.run(); \
    std::cout<<"Test OK.\n";\
}

// Call this at the end of your testsuite.
void endTestSuite();

} // namespace Ge

#endif // !TEST_FRAMEWORK_H