#include "Precompiled.h"

//------------------------------------------------------------------------------
// (c) 03-2001 Gottfried Chen
//------------------------------------------------------------------------------

#include <System/Timer.h>
#include <time.h>

namespace Ge
{

//------------------------------------------------------------------------------
Timer::Timer() :
//------------------------------------------------------------------------------
mReference(clock())
{
}

//------------------------------------------------------------------------------
const Timer& Timer::system()
//------------------------------------------------------------------------------
{
    static Timer systemTimer;
    return systemTimer;
}


//------------------------------------------------------------------------------
Timer::Unit Timer::get(Timer::Resolution res) const
//------------------------------------------------------------------------------
{
    Unit multiplicator = res == MILLISECONDS ? Unit(1) : Unit(0.001);
    return (clock() - mReference)*multiplicator;
}


//------------------------------------------------------------------------------
void Timer::reset()
//------------------------------------------------------------------------------
{
    mReference = clock();
}

} // namespace Ge