//------------------------------------------------------------------------------
// (c) 03-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef SYSTEM_TIMER_H
#define SYSTEM_TIMER_H

#include <System/Types.h>

namespace Ge
{

// This represents a basic timer class
class Timer
{
public:
    typedef Double Unit;
    
    Timer();

    enum Resolution
    {
        MILLISECONDS,
        DEFAULT = MILLISECONDS
    };

    // The one and only system timer. It is normally started by
    // the framework on startup and used e.g. for logging
    static
    const Timer& system();
    
    Unit get(Resolution res = DEFAULT) const;
    void reset();

private:
    Unit mReference;
};

} // namespace Ge

#endif // SYSTEM_TIMER_H