//------------------------------------------------------------------------------
// (c) 03-2001 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef SYSTEM_TYPES_H
#define SYSTEM_TYPES_H

#pragma warning(disable: 4275) // Some dll warning due to <complex>
#include <complex>

namespace Ge
{

// These typedefs are used, so that e.g. sharing binary files over
// multiple platforms is possible. Sizes are not guaranteed.
typedef float Float;
typedef double Double;
typedef std::complex<Float> Complex;
typedef std::complex<Double> ComplexD;
typedef int Int;
typedef unsigned int UInt;

// Guaranteed sizes
typedef signed char Int8;
typedef unsigned char UInt8;
typedef short Int16;
typedef unsigned short UInt16;
typedef long Int32;
typedef unsigned long UInt32;

// Other types
typedef void* Handle;
template<class T>
struct Rect
{
    Rect(T left = 0, T top = 0, T right = 0, T bottom = 0) :
    mLeft(left), mTop(top), mRight(right), mBottom(bottom) {}
  
    T mLeft;
    T mTop;
    T mRight;
    T mBottom;
};

} // namespace Ge

#endif // SYSTEM_TYPES_H