#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 02-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "ComplexMap.h"

namespace Ge
{

//------------------------------------------------------------------------------
unsigned char ComplexMap::get(unsigned int x, unsigned int y) const
//------------------------------------------------------------------------------
{
    return 255*(mMap[y*mXSize+x].real()-mMin)/mRange;
}

//------------------------------------------------------------------------------
unsigned int ComplexMap::getXSize() const
//------------------------------------------------------------------------------
{
    return mXSize;
}

//------------------------------------------------------------------------------
unsigned int ComplexMap::getYSize() const
//------------------------------------------------------------------------------
{
    return mYSize;
}

//------------------------------------------------------------------------------
ComplexMap::ComplexMap(const std::complex<float>* map, unsigned int xSize, unsigned int ySize,
                       float min, float max) :
//------------------------------------------------------------------------------
mMap(map),
mXSize(xSize),
mYSize(ySize),
mMin(min),
mRange(max-min)
{
    GE_ASSERT(max>min);
}

} // namespace Ge