//------------------------------------------------------------------------------
// (c) 01-2002 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef COMPLEXMAP_H
#define COMPLEXMAP_H

#include "HeightMap.h"
#include <complex>

namespace Ge
{

class ComplexMap : public HeightMapImpl
{
public:
    virtual
    unsigned char get(unsigned int x, unsigned int y) const;
    
    virtual
    unsigned int getXSize() const;

    virtual
    unsigned int getYSize() const;

private:
    friend class HeightMap;
    ComplexMap(const std::complex<float>* map, unsigned int xSize, unsigned int ySize,
               float min, float max);

    const std::complex<float>* mMap;
    unsigned int mXSize;
    unsigned int mYSize;
    float mMin;
    float mRange;
};

} // namespace Ge

#endif // COMPLEXMAP_H