#include "Precompiled.h"

#include "FloatMap.h"

namespace Ge
{

//------------------------------------------------------------------------------
unsigned char FloatMap::get(unsigned int x, unsigned int y) const
//------------------------------------------------------------------------------
{
    return 255*(mMap[y*mXSize+x]-mMin)/mRange;
}

//------------------------------------------------------------------------------
unsigned int FloatMap::getXSize() const
//------------------------------------------------------------------------------
{
    return mXSize;
}

//------------------------------------------------------------------------------
unsigned int FloatMap::getYSize() const
//------------------------------------------------------------------------------
{
    return mYSize;
}

//------------------------------------------------------------------------------
FloatMap::FloatMap(const float* map, unsigned int xSize, unsigned int ySize,
                   float min, float max) :
//------------------------------------------------------------------------------
mMap(map),
mXSize(xSize),
mYSize(ySize),
mMin(min),
mRange(max-min)
{
    GE_ASSERT(max>min);
}

} // namespace Ge