//------------------------------------------------------------------------------
// (c) 01-2002 Gottfried Chen
//------------------------------------------------------------------------------

#ifndef FLOATMAP_H
#define FLOATMAP_H

#include "HeightMap.h"

namespace Ge
{

class FloatMap : public HeightMapImpl
{
public:
    virtual
    unsigned char get(unsigned int x, unsigned int y) const;
    
    virtual
    unsigned int getXSize() const;

    virtual
    unsigned int getYSize() const;

private:
    friend class HeightMap;
    FloatMap(const float* map, unsigned int xSize, unsigned int ySize,
             float min, float max);

    const float* mMap;
    unsigned int mXSize;
    unsigned int mYSize;
    float mMin;
    float mRange;
};

} // namespace Ge

#endif // FLOATMAP_H