#include "Precompiled.h"
//------------------------------------------------------------------------------
// (c) 01-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "ImageHeightMap.h"
#include <Image/Image.h>

namespace Ge
{

//------------------------------------------------------------------------------
ImageHeightMap::ImageHeightMap(Image& image) :
//------------------------------------------------------------------------------
mImage(image),
mBytesPerPixel(image.getBitDepth()/8)
{
}

//------------------------------------------------------------------------------
unsigned char ImageHeightMap::get(unsigned int x, unsigned int y) const
//------------------------------------------------------------------------------
{
    GE_ASSERT(x<getXSize() && y<getYSize());
    // If the image has more than one byte per pixel, only the first byte
    // is interpreted for the height. This is done to support greyscale
    // heightmaps that were saved as true color images.
    return (mImage.getData())[
        ((mImage.getHeight()-1-y)*mImage.getWidth()+x)*mBytesPerPixel];
}

//------------------------------------------------------------------------------
unsigned int ImageHeightMap::getXSize() const
//------------------------------------------------------------------------------
{
    return mImage.getWidth();
}

//------------------------------------------------------------------------------
unsigned int ImageHeightMap::getYSize() const
//------------------------------------------------------------------------------
{
    return mImage.getHeight();
}

} // namespace Ge


