#ifndef BUMP_CONTEXT_H
#define BUMP_CONTEXT_H
#pragma once

//------------------------------------------------------------------------------
// (c) Sep-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include <Application/Context.h>

#include <Engine/Camera.h>
#include <Engine/ModelViewCameraController.h>
#include <Engine/World.h>

namespace Ge
{

class Link;

// This is used as a visual unit testing context. It tests some basic stuff like
// texturing, quads and so on
class BumpContext : public Context
{
public:
    BumpContext();

    virtual void init();

    virtual void update();

    virtual void render();

    virtual void exit();

private:
    Camera mCamera;
    ModelViewCameraController mCameraController;
    World mWorld;
    Vector3 mLight;
    Link* mLink;
    Link* mLinkClone;
    Link* mLinkFlip;
};

} // namespace Ge

#endif // !BUMP_CONTEXT_H