#ifndef CHOPPY_WAVES_CONTEXT_H
#define CHOPPY_WAVES_CONTEXT_H

//------------------------------------------------------------------------------
// (c) 04-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "WaterContextBase.h"

#include <System/Base.h>

#include <Input/DeviceButton.h>
#include <Input/RepeatButton.h>

#include <Terrain/ChoppyWaves.h>
#include <Terrain/DeltaXzMap.h>

#include <Math/Vector.h>

namespace Ge
{

class Mesh;

class ChoppyWavesContext : public WaterContextBase
{
public:
    ChoppyWavesContext();

    virtual void init();

    virtual void update();

    virtual void exit();
    
private:
    void updateChoppiness();

    ChoppyWaves mChoppyWaves;
    Mesh* mMesh;
    Vector3* mVertices;
    Vector3* mNormals;
    UInt16* mIndices;
    DeltaXzMap mDeltaMap;

    KeyboardButton mIncChop;
    KeyboardButton mDecChop;
    RepeatButton mRepIncChop;
    RepeatButton mRepDecChop;
};

} // namespace Ge

#endif // CHOPPY_WAVES_CONTEXT_H