#ifndef LWS_IMPORT_CONTEXT_H
#define LWS_IMPORT_CONTEXT_H
#pragma once

//------------------------------------------------------------------------------
// (c) Jun-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include <Application/Context.h>

#include <Engine/Camera.h>
#include <Engine/ModelViewCameraController.h>
#include <Engine/World.h>
#include <Engine/Light.h>
#include <Engine/HierarchyAnimation.h>

#include <System/Pointer.h>

#include <Input/DeviceButton.h>
#include <Input/RepeatButton.h>

namespace Ge
{

class LwsImportContext : public Context
{
public:
    LwsImportContext();

    virtual void init();

    virtual void update();

    virtual void render();

    virtual void exit();

private:
    void openModel(const char* = 0);

    void toggleAnim();

    // Anim speed is multiplied by <factor>
    void changeAnimSpeed(Float factor);

    Camera mCamera;
    ModelViewCameraController mCameraController;
    World* mWorld;
    Pointer<Light> mLight;
    HierarchyAnimation mAnimation;
    Cluster* mModel;

    KeyboardButton mOpenFile;

    KeyboardButton mToggleAnim;
    KeyboardButton mDecAnimSpeed;
    KeyboardButton mIncAnimSpeed;
    RepeatButton mRepDecAnimSpeed;
    RepeatButton mRepIncAnimSpeed;
    Float mAnimSpeed;
    bool mAnimOn;
};

} // namespace Ge

#endif // !LWS_IMPORT_CONTEXT_H