#ifndef MD3_CONTEXT_H
#define MD3_CONTEXT_H
#pragma once

//------------------------------------------------------------------------------
// (c) Aug-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include <Application/Context.h>

#include <Engine/Camera.h>
#include <Engine/ModelViewCameraController.h>
#include <Engine/World.h>

#include <Input/DeviceButton.h>

namespace Ge
{

class Md3Model;
class Light;

class Md3Context : public Context
{
public:
    Md3Context();

    virtual void init();

    virtual void update();

    virtual void render();

    virtual void exit();

protected:
    static const UInt TEXT_X_POS;
    static const UInt TEXT_Y_POS;

    Camera mCamera;
    ModelViewCameraController mCameraController;
    Md3Model* mModel;
    World* mWorld;
    Light* mLight;
    KeyboardButton mNextTorsoAnim;
    UInt mCurrentTorsoAnim;
    KeyboardButton mNextLegsAnim;
    UInt mCurrentLegsAnim;
    KeyboardButton mStartAnim;
    KeyboardButton mNextModel;
    UInt mCurrentModel;
};

} // namespace Ge

#endif // !MD3_CONTEXT_H