#ifndef NEWAVE_CONTEXT_H
#define NEWAVE_CONTEXT_H
#pragma once

//------------------------------------------------------------------------------
// (c) Mai-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "WaterContextBase.h"

#include <System/Base.h>

#include <Engine/Pick.h>

#include <Input/DeviceButton.h>

#include <Terrain/Newave.h>

namespace Ge
{

class Mesh;

class NewaveContext : public WaterContextBase
{
public:
    NewaveContext();

    virtual void init();

    virtual void update();

    virtual void exit();
    
private:
    void updateDrop();

    Newave mNewave;
    Mesh* mMesh;
    Vector3* mVertices;
    Vector3* mNormals;
    UInt16* mIndices;

    KeyboardButton mDrop;
    Pick mPick;
};

} // namespace Ge

#endif // !NEWAVE_CONTEXT_H