#ifndef PARTICLE_CONTEXT_H
#define PARTICLE_CONTEXT_H
#pragma once

//------------------------------------------------------------------------------
// (c) Aug-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include <Application/Context.h>

#include <Engine/Camera.h>
#include <Engine/ModelViewCameraController.h>
#include <Engine/Emitter.h>

namespace Ge
{

class ParticleContext : public Context
{
public:
    ParticleContext();

    virtual void init();

    virtual void update();

    virtual void render();

    virtual void exit();

private:
    Camera mCamera;
    ModelViewCameraController mCameraController;
    Emitter mFire;
    Emitter mSmoke;
};

} // namespace Ge

#endif // !PARTICLE_CONTEXT_H