#ifndef SHADOW_VOLUME_CONTEXT_H
#define SHADOW_VOLUME_CONTEXT_H
#pragma once

//------------------------------------------------------------------------------
// (c) Jul-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include <Application/Context.h>

#include <Engine/Camera.h>
#include <Engine/ModelViewCameraController.h>
#include <Engine/World.h>
#include <Engine/Light.h>
#include <Engine/ShadowVolume.h>
#include <Engine/Emitter.h>

#include <Math/Vector.h>

#include <Input/DeviceButton.h>


namespace Ge
{

class ShadowVolumeContext : public Context
{
public:
    ShadowVolumeContext();

    virtual void init();

    virtual void update();

    virtual void render();

    virtual void exit();

private:
    Camera mCamera;
    ModelViewCameraController mCameraController;
    World mWorld;
    Pointer<Light> mLight;
    Emitter mLightParticles;
};

} // namespace Ge

#endif // !SHADOW_VOLUME_CONTEXT_H