#ifndef TERRAIN_CONTEXT_H
#define TERRAIN_CONTEXT_H
#pragma once

//------------------------------------------------------------------------------
// (c) Jun-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include <Application/Context.h>

#include <Engine/World.h>
#include <Engine/Camera.h>
#include <Engine/Light.h>
#include <Engine/ModelViewCameraController.h>

#include <Input/DeviceButton.h>

#include <System/Pointer.h>

namespace Ge
{

class TerrainContext : public Context
{
public:

    TerrainContext();

    virtual void init();

    virtual void update();

    virtual void render();

    virtual void exit();

private:
    enum Algorithm
    {
        ALGORITHM_START = 0,
        IMAGE_MAP = ALGORITHM_START,
        FAULT_FORMATION,
        MIDPOINT_DISPLACEMENT,
        PARTICLE_DEPOSITION,
        ALGORITHM_COUNT
    };

    // Regenerate the terrain using the current algorithm.
    void generateWorld();

    World* mWorld;
    Camera mCamera;
    ModelViewCameraController mCameraController;
    Pointer<Light> mLight;

    KeyboardButton mChangeAlgorithm;
    Algorithm mCurrentAlgorithm;
};

} // namespace Ge

#endif // !TERRAIN_CONTEXT_H