#ifndef TEST_CONTEXT_H
#define TEST_CONTEXT_H
#pragma once

//------------------------------------------------------------------------------
// (c) Jul-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include <Application/Context.h>

#include <Engine/Camera.h>
#include <Engine/ModelViewCameraController.h>
#include <Engine/World.h>
#include <Engine/Light.h>

namespace Ge
{

// This is used as a visual unit testing context. It tests some basic stuff like
// texturing, quads and so on
class TestContext : public Context
{
public:
    TestContext();

    virtual void init();

    virtual void update();

    virtual void render();

    virtual void exit();

private:
    Camera mCamera;
    ModelViewCameraController mCameraController;
    World mWorld;
    Light* mLight;
};

} // namespace Ge

#endif // !TEST_CONTEXT_H