#ifndef TEST_FRAMEWORK_H
#define TEST_FRAMEWORK_H

#include "ChoppyWavesContext.h"
#include "NewaveContext.h"
#include "Water2DContext.h"
#include "GerstnerWavesContext.h"
#include "TerrainContext.h"
#include "LwsImportContext.h"
#include "ShadowVolumeContext.h"
#include "TestContext.h"
#include "ParticleContext.h"
#include "Md3Context.h"
#include "BumpMd3Context.h"
#include "BumpContext.h"

#include <Application/Framework.h>

#include <Input/DeviceButton.h>
#include <Input/ModButton.h>

#include <vector>

class MfcWindow;

namespace Ge
{

class TestFramework : public Framework
{
public:
    TestFramework();
    
    ~TestFramework();

    MfcWindow* getMfcWindow();
    
    virtual void init();

    virtual void update();

    virtual void exit();

protected:
    virtual Handle createWindow();
   
private:
    MfcWindow* mMfcWindow;

    ChoppyWavesContext mChoppyWaves;
    NewaveContext mNewave;
    Water2DContext mWater2D;
    GerstnerWavesContext mGerstner;
    TerrainContext mTerrain;
    LwsImportContext mLws;
    ShadowVolumeContext mShadowVolume;
    TestContext mUnitTest;
    ParticleContext mParticles;
    Md3Context mMd3;
    BumpMd3Context mBumpMd3;
    BumpContext mBumpContext;
    
    typedef std::vector<Context*> Contexts;
    Contexts mContexts;
    KeyboardButton mNextContext;
    KeyboardButton mModifier;
    ModButton mPreviousContext;
    Int mCurrentContext;
};

extern TestFramework theFramework;

} // namespace Ge

#endif // TEST_FRAMEWORK_H