#ifndef WATER_2D_CONTEXT_H
#define WATER_2D_CONTEXT_H
#pragma once

//------------------------------------------------------------------------------
// (c) Mai-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include "WaterContextBase.h"

#include <System/Base.h>

#include <Engine/Pick.h>

#include <Input/DeviceButton.h>

#include <Terrain/Water2D.h>

namespace Ge
{

class Mesh;

class Water2DContext : public WaterContextBase
{
public:
    Water2DContext();

    virtual void init();

    virtual void update();

    virtual void exit();

private:
    void updateDrop();

    Water2D mWater;
    Mesh* mMesh;
    Vector3* mVertices;
    Vector3* mNormals;
    UInt16* mIndices;

    KeyboardButton mDrop;
    Pick mPick;
};

} // namespace Ge

#endif // !WATER_2D_CONTEXT_H