#ifndef WATER_CONTEXT_BASE_H
#define WATER_CONTEXT_BASE_H
#pragma once

//------------------------------------------------------------------------------
// (c) Jun-2002 Gottfried Chen
//------------------------------------------------------------------------------

#include <Application/Context.h>

#include <Engine/World.h>
#include <Engine/Camera.h>
#include <Engine/Light.h>
#include <Engine/ModelViewCameraController.h>

#include <Input/DeviceButton.h>
#include <Input/RepeatButton.h>

namespace Ge
{

// Just a quick hack base class for the different water contexts.
class WaterContextBase : public Context
{
public:
    virtual void init();

    virtual void update();

    virtual void render();

protected:
    WaterContextBase(const char* name,
                     Float waterHeight, Float waterHeightDelta);
    
    Float getWaterHeight();

    const World& getWorld() const;

    World& getWorld();

    Light& getLight();

    const Camera& getCamera() const;

private:
    void updateHeight();

    Camera mCamera;
    ModelViewCameraController mCameraController;
    World mWorld;
    Pointer<Light> mLight;

    Float mWaterHeight;
    Float mWaterHeightDelta;
    KeyboardButton mIncHeight;
    KeyboardButton mDecHeight;
    RepeatButton mRepIncHeight;
    RepeatButton mRepDecHeight;
};

} // namespace Ge

#endif // !WATER_CONTEXT_BASE_H